#include <stdio.h>
#include <stdlib.h>

#include "vesa.h"
#include "vesa_class.h"

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

int main() {
  int md;

  VbeGetInfo();
  printf("Vesa card: %s\n",AP[*((dword*)(vbeinfo.VbeSignature))==0x41534556]);
  printf("Version: %x.%x\n",vbeinfo.VbeVersionF.High,vbeinfo.VbeVersionF.Low);
  printf("Oem name: %Fs\n",vbeinfo.OemStringPtr);
  printf("Video memory: %i MB\n",vbeinfo.TotalMemory >> 4);

  md = g320x200x16M;
  VbeGetModeInfo(md);
  printf("\nMode: %ix%i at %ibpp\n",modeinfo.XResolution,modeinfo.YResolution,modeinfo.BitsPerPixel);
  printf("Supported: %s\n",TF[modeinfo.ModeAttributesF.Supported]);
  printf("Linear buffer: %s\n",TF[modeinfo.ModeAttributesF.LinearBuffer]);
  printf("RGB: %i:%i:%i\n",modeinfo.RedMaskSize,modeinfo.GreenMaskSize,modeinfo.BlueMaskSize);
  printf("Linear RGB: %i:%i:%i\n",modeinfo.LinRedMaskSize,modeinfo.LinGreenMaskSize,modeinfo.LinBlueMaskSize);
  printf("ScanLine size: %i, %i (linear)\n",modeinfo.BytesPerScanLine,modeinfo.LinBytesPerScanLine);
  getchar();

  virtualScreenVesa *vir1 = new virtualScreenVesa();
  VbeSetMode(md | PreserveMemory);

  getchar();

  delete vir1;

  return(0);
}

/*

void main()
  {
    int md,wn,x,y;
    RGBcol col, col2;

    clrscr();



    col.r = 0; col.g = 0; col.b = 0;
    vir1->clear(col);

    randomize();
    //col.r = random(32);
    //col.g = random(64);
    //col.b = random(32);
    col.r = 3;
    col.g = 2;
    col.b = 3;
    //col2.r = 1;
    //col2.g = 0;
    //col2.b = 0;
    vir1->drawMode = DM_ADD;
    while (!kbhit()) {
      int a,b;
    col.r = random(32/1);
    col.g = random(64/1);
    col.b = random(32/1);

      //col = col+col2;
      //vir1->line(random(320),random(200),random(320),random(200),col);
      x = random(320);
      y = random(200);
      vir1->frect(x,y,x+random(50),y+random(30),col/2);
      //vir1->movement(20,20,300,180, &trans);

      if (a%8==0) vir1->blur(0,0,319,199);
      //if ((a%16==0)) vir1->testf(10,10,310,180);

      if (a%4==0) vir1->show();
      a++;
    }
    getch();

    delete vir1;
    textmode(3);
    //printf("pnt %Fp",pn);
}
*/