// VESA test program
#include <stdio.h>
// #include <conio.h>
#include <stdlib.h>
//#include <alloc.h>

#include <dos.h>
//#include <util.h>
//#include <vgapal.h>
//#include <vga.h>
#include "vesa.h"

#define min(a,b)  (((a)<=(b))?(a):(b))
#define max(a,b)  (((a)>=(b))?(a):(b))

#define DM_NORMAL       00
#define DM_ADD          01
#define DM_SUB1         02
#define DM_SUB2         03
#define DM_MUL          04
#define DM_XOR          05
#define DM_MIN          06
#define DM_MAX          07
#define DM_NONE       0xFF

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

typedef struct { byte b,g,r, align; } RGBcol;

/*void VbePutPixel(word x, word y, RGBcol color) {
  dword base = (dword)modeinfo.WinASegment << 16;
  dword ofs = ((dword)modeinfo.XResolution*y+x)*(modeinfo.BitsPerPixel >> 3);
  if (curBank != ofs >> 16) {
    VbeSetDisplayWindow(0,ofs >> 16);
    curBank = ofs >> 16;
  }
  switch (modeinfo.BitsPerPixel) {
    case 8: {  // 256 color mode (palette, use color.b for color number)
      char far *pn = (char far *)(base+(word)ofs);
      *pn = color.b;
      break;
    }
    case 16: {
      word far *pn = (word far *)(base+(word)ofs);
      *pn = packCol16(color);
      break;
    }
    case 32: {
      char far *pn = (char far *)(base+(word)ofs);
      asm {
    les   di, pn
    mov   ax, word ptr color[0]
    stosw
    mov   al, byte ptr color[2]
    mov   es:[di], al
      }
      break;
    }
  }
}*/

class virtualScreenVesa {
  public:
    int drawMode, drawMode_RC;
    virtualScreenVesa();
    ~virtualScreenVesa();
    virtual int error(int id);
    void clear(RGBcol color);
    void show();
    void copyTo(virtualScreenVesa *virscr);

    virtual void putpixel(word x, word y, RGBcol color);
    void line(word x1, word y1, word x2, word y2, RGBcol color);
    void frect(word x1, word y1, word x2, word y2, RGBcol color);

  protected:
    dword blockSize;
    word totBlocks;
    byte far *screen[8];  // max 8 memblock of 64Kb = 512Kb max!
    word far *getPnt(word x, word y);
};

virtualScreenVesa::virtualScreenVesa() {
  int i;
  drawMode = DM_NORMAL;
  drawMode_RC = 0;
  blockSize = 65535;//modeinfo.WinSize*1024;
  totBlocks = ((dword)modeinfo.YResolution*modeinfo.BytesPerScanLine)/(modeinfo.WinSize);
  totBlocks = totBlocks/1024 + (((totBlocks%1024)==0)?0:1);
  if (totBlocks > 8) error(4);

  for (i=0;i<totBlocks;i++) {
    word tSeg;
    if (_dos_allocmem(0x1000, &tSeg) != 0) error(0);
    screen[i] = (byte far *)((dword)tSeg << 16);
    /*screen[i] = (byte far *)farmalloc(blockSize);
    if (screen[i] == NULL) error(0);*/
  }
  //bufferIn = screen[0];
  //bufferOut = screen[0];

}

virtualScreenVesa::~virtualScreenVesa() {
  int i;
  for (i=0;i<totBlocks;i++) {
    //if (screen[i] == NULL) error(1); else farfree(screen[i]);
    word tSeg = (word)((dword)screen[i] >> 16);
    if (tSeg == NULL) error(1); else if (_dos_freemem(tSeg) != 0) error(2);
  }
}

int virtualScreenVesa::error(int id) {
  __asm {
    MOV  AX, 0x0003
    INT  0x10
  }
  printf("ERROR %i",id);
  getchar();
  exit(1);
  return(id);
}

void virtualScreenVesa::clear(RGBcol color) {
  int i;
  i = color.r;
  for (i=0;i<totBlocks;i++) {
    /*_fmemset(screen[i], clr, blockSize);
    *((word far *)screen[i]+0xFFFE) = clr;*/
  }
}

void virtualScreenVesa::show() {
  int i;
  void far *videoPtr = (void far *)((dword)modeinfo.WinASegment << 16);
  for (i=0;i<totBlocks;i++) {
    byte far *pnt = screen[i];
    VbeSetDisplayWindow(0,i);
    __asm {
      push  es
      push  di
      push  ds
      push  si
      les   di, videoPtr
      lds   si, pnt
      mov   cx, 0x8000
      rep   movsw
      pop   si
      pop   ds
      pop   di
      pop   es
    }
    /*_fmemcpy(videoPtr, screen[i], blockSize);
    *((byte far *)videoPtr+0xFFFF) = *(screen[i]+0xFFFF);*/
  }
}

void virtualScreenVesa::copyTo(virtualScreenVesa *virscr) {
  int i;
  byte far *dest, far *source;
  for (i=0;i<min(totBlocks,virscr->totBlocks);i++) {
    dest = screen[i];
    source = virscr->screen[i];
    __asm {
      push  es
      push  di
      push  ds
      push  si
      les   di, dest
      lds   si, source
      mov   cx, 0x8000
      rep   movsw
      pop   si
      pop   ds
      pop   di
      pop   es
    }
  }
}


void virtualScreenVesa::putpixel(word x, word y, RGBcol color) {
  switch (modeinfo.BitsPerPixel) {
    case 8: {  // 256 color mode (palette, use color.b for color number)
      char far *pn = (char far *)getPnt(x,y);
      *pn = color.b;
      break;
    }
    case 16: {
      word far *pn = getPnt(x,y);
      switch (drawMode) {
        case DM_ADD: break;
        case DM_NORMAL: ;
        default: ;
      }
      break;
    }
    case 32: {
      byte far *pn = (byte far *)getPnt(x,y);
      __asm {
        push  es
        push  di
        les   di, pn
        mov   ax, word ptr color[0]
        stosw
        mov   al, byte ptr color[2]
        mov   es:[di], al
        pop   di
        pop   es
      }
      break;
    }
  }
}

void virtualScreenVesa::line(word x1, word y1, word x2, word y2, RGBcol color) {
  int dx = x2-x1, dy = y2-y1,
      ix = abs(dx), iy = abs(dy),
      inct = (ix>iy?ix:iy),
      plotX = x1, plotY = y1,
      x = 0, y = 0,
      i;
  byte plot;
  putpixel(plotX,plotY, color);
  for (i=0;i<=inct;i++) {
    x += ix;
    y += iy;
    plot = 0;
    if (x > inct) {
      plot = 1;
      x -= inct;
      if (dx > 0) plotX++;
      if (dx < 0) plotX--;
     }
     //if (y = inct) putpixel(plotX, plotY, color/2);
     if (y > inct) {
       plot = 1;
       y -= inct;
       if (dy > 0) plotY++;
       if (dy < 0) plotY--;
     }
     if (plot) putpixel(plotX,plotY, color);
  }
}

void virtualScreenVesa::frect(word x1, word y1, word x2, word y2, RGBcol color) {
  word j, p;
  for (j=y1;j<=y2;j++)
    for (p=x1;p<=x2;p++) putpixel(p,j,color);
}

word far *virtualScreenVesa::getPnt(word x, word y) {
  dword base;
  //dword ofs = ((dword)modeinfo.XResolution*y+x)*(modeinfo.BitsPerPixel >> 3);
  word ofs;
  word Xsize = modeinfo.XResolution;
  byte bpp = modeinfo.BitsPerPixel;
  __asm {
    mov   ax, Xsize
    mul   y
    add   ax, x
    adc   dx, 0
    mov   cl, bpp
    shr   cl, 4
    jz    skipShift // jump if bpp = 8
    shl   dx, cl
    rol   ax, cl
    mov   bl, al
    and   bl, cl
    or    dl, bl
    or    cl, 1
    not   cl
    and   al, cl
   skipShift:
    mov   ofs, ax
    mov   word ptr base[0], dx
  }
  base = (dword)screen[(byte)base];
  return (word far *)(base | ofs);
}
