#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <mem.h>

#define DEBUG
#define SUDOKU_SIZE     9

typedef char SUDOKU[SUDOKU_SIZE][SUDOKU_SIZE];
const char simbols[SUDOKU_SIZE] = {'0','1','2','3','4','5','6','7','8'};


#ifdef DEBUG
void debug_printSudoku(SUDOKU *s) {
  for (int j=0; j<SUDOKU_SIZE; j++) {
    for (int i=0; i<SUDOKU_SIZE; i++) {
      printf("%4c",(*s)[j][i]);
    }
    printf("\n");
  }
  printf("\n");
}
#endif

SUDOKU s1;
long long counter = 0;

/*long long pot(int base, int expon) {
  long long ret = 1;
  for (int i=0; i<expon; i++)
    ret *= base;
  return(ret);
}

long long fact(int n) {
  long long ret = 1;
  for (int i=2; i<=n; i++)
    ret *= i;
  return(ret);
}

long long binom(int n, int k) {
  return(fact(n)/(fact(k)*fact(n-k)));
}*/

void genFirst(SUDOKU *s) {
  for (int i=0; i<SUDOKU_SIZE*SUDOKU_SIZE; i++) {
    *((char*)s+i) = simbols[i % SUDOKU_SIZE];
    //*((char*)s+i) = simbols[0];
  }
}

void permuLine(SUDOKU *s, int line, int pos) {
  char t;
  if (line >= SUDOKU_SIZE) return;
  if (pos >= SUDOKU_SIZE) return;

  for (int i=pos; i<SUDOKU_SIZE; i++) {
    if (i == pos)
      permuLine(s, line, pos+1);
    else {
      t = (*s)[line][pos];
      (*s)[line][pos] = (*s)[line][i];
      (*s)[line][i] = t;
      permuLine(s, line, pos+1);
      (*s)[line][i] = (*s)[line][pos];
      (*s)[line][pos] = t;
    }
  }
}

int checkSudokuLine(SUDOKU *s, int line) {
  char cr[SUDOKU_SIZE], cc[SUDOKU_SIZE];
  int i,j;

  for (j=0; j<line; j++) {
    memset(cr, 0, SUDOKU_SIZE);
    memset(cc, 0, SUDOKU_SIZE);
    for (i=0; i<SUDOKU_SIZE; i++) {
      if (cr[(*s)[j][i]] != 0) return(0); else cr[(*s)[j][i]] = 1; // checks rows
      if (cc[(*s)[i][j]] != 0) return(0); else cc[(*s)[i][j]] = 1; // checks columns
    }
  }
  return(1);
}

int checkSudoku(SUDOKU *s) {
  return(checkSudokuLine(s, SUDOKU_SIZE));
}

void genSudoku(SUDOKU *s, int pos) {
  int i;

  if (kbhit()) {
    getch();
    printf("Counter: %lli\n",counter);
    debug_printSudoku(s);
    printf("press ESC to stop or another key to continue\n");
    char u = getch();
    if (u == 0x1B) exit(-1);
    printf("Restart...\n");
  }

  if (pos >= SUDOKU_SIZE*SUDOKU_SIZE) {
    //debug_printSudoku(s);
    counter++;
    //printf("%lli\n",counter);
    return;
  }
  if ((pos>0)&&((pos % SUDOKU_SIZE) == 0)) {
    if (!checkSudokuLine(s, pos / SUDOKU_SIZE)) return;

  }
  for (i=0; i<SUDOKU_SIZE; i++) {
    *((char*)s+pos) = simbols[i];
    genSudoku(s, pos+1);
  }
  /*for (i=0; i<SUDOKU_SIZE; i++) {
    permuLine(s, i);
  }*/
}

void genSudoku2(SUDOKU *s, int line, int pos) {
  char t;
  if (line >= SUDOKU_SIZE) return;
  if (pos >= SUDOKU_SIZE) return;

  for (int i=pos; i<SUDOKU_SIZE; i++) {
    if (i == pos)
      permuLine(s, line, pos+1);
    else {
      t = (*s)[line][pos];
      (*s)[line][pos] = (*s)[line][i];
      (*s)[line][i] = t;
      permuLine(s, line, pos+1);
      (*s)[line][i] = (*s)[line][pos];
      (*s)[line][pos] = t;
    }
  }
}



int main() {
  printf("SUDOKU GAME\n\n");

  printf("Dimensione: %i\n",SUDOKU_SIZE);
  //printf("Combinazioni totali: %lli\n", pot(SUDOKU_SIMBOLS, SUDOKU_SIZE*SUDOKU_SIZE));
  //printf("Permutazioni totali: %lli\n", pot(fact(SUDOKU_SIMBOLS),SUDOKU_SIZE));
  //printf("Permutazioni totali: %lli\n", binom(4+16-1,16));

  genFirst(&s1);
  debug_printSudoku(&s1);
  //genSudoku(&s1, 0);
  //printf("contati: %lli\n",counter);


  getch();
  return(0);
}
