#pragma option -f287
//#define  USEASSEMBLY

#include <dos.h>
#include <conio.h>
#include <math.h>
#include <crt.h>
#include <vga.h>
#include <vgapal.h>
#include <mouse.h>

int rad = 20;
VirtualScreen *screen;
pal256 pal;

void pol2rec_f8(double rho, double theta, double *x, double *y);
void rec2pol_f8(double x, double y, double *rho, double *theta);

#ifdef USEASSEMBLY

//#pragma option -k-
inline void finit() { __emit__(0x9B,0xDB,0xE3); }
//#pragma option -k

void pol2rec_f8(double rho, double theta, double *x, double *y) {
  asm {
    //db    0x9B,0xDB,0xE3 // finit
    fld   theta
    db    0xD9,0xFB      // fsincos
    fmul  rho
    mov   bx, x
    fstp  qword [bx]
    fmul  rho
    mov   bx, y
    fst   qword [bx]
  }
}

void rec2pol_f8(double x, double y, double *rho, double *theta) {
  asm {
    //db    0x9B,0xDB,0xE3 // finit
    fld   x
    fmul  x
    fld   y
    fmul  y
    fadd  st(0), st(1)
    fsqrt
    mov   bx, rho
    fst   qword [bx]
    fld   y
    fld   x
    fpatan
    mov   bx, theta
    fst   qword [bx]
  }
}
#else
void pol2rec_f8(double rho, double theta, double *x, double *y) {
  *x = cos(theta)*rho;
  *y = sin(theta)*rho;
}

void rec2pol_f8(double x, double y, double *rho, double *theta) {
  *rho = sqrt(x*x+y*y);
  if (x == 0 && y == 0) *theta = 0.0; else *theta = atan2(y,x);
}

#endif

void doTrans(int x, int y) {
  int i,j;
  BYTE col;
  double rho,theta, nx,ny, t;

  for (j=0; j<VGA_HEIGHT; j++) {
    for (i=0; i<VGA_WIDTH; i++) {
      rec2pol_f8(i-x, j-y, &rho, &theta);
        //t = 7.0/(exp(-(rad-rho))+1.0);
        //t = atan(rad-rho);
        rho = (rho-rad);
        //theta = theta*1.1;
      pol2rec_f8(rho, theta, &nx,&ny);
      col = (int)(x+nx)^(int)(y+ny);
      //col = (t)*30;
      if (((int)(x+nx))%16 == 0) col = 100;
      if (((int)(y+ny))%16 == 0) col = 100;
      screen->putPixel(i,j, col);
    }
  }
}

void main() {
  int mx,my, tx = 1;

  crt_init();

  if (!mouse_reset()) {
    puts("Mouse needed!\n");
    exit(1);
  }

  crt_setVideoMode(0x13);
  screen = new VirtualScreen();
  screen->clear(0);
  pal_setGradient(&pal,0,127,0,0,0,0,0,43);
  pal_setGradient(&pal,127,255,0,0,43,63,33,50);
  pal_outAll(&pal);

  //mouse_show();
  //screen->drawMode = DM_BLEND;
  mouse_getStatus();
  mx = mouseInfo.xPos>>1;
  my = mouseInfo.yPos;

  do {
    //screen->clear(0);
    mouse_getStatus();
    mouseInfo.xPos >>= 1;
    screen->putPixel(mouseInfo.xPos,mouseInfo.yPos, 5);
    if (mouseInfo.rightButton) {
      tx = 0;
      rad = ++rad%80;
    }

    doTrans(mouseInfo.xPos,mouseInfo.yPos);
    screen->circle(mouseInfo.xPos,mouseInfo.yPos, rad, 200);
    if (tx) {
      if ((mouseInfo.xPos != mx)||(mouseInfo.yPos != my)) tx = 0;
      else screen->text(50,80,"Move that fucking mouse!",1,250);
    }
    //mouse_hide();
    screen->show();
    //screen->blur(0,0,VGA_MAXX,VGA_MAXY);
    //mouse_show();
    delay(10);
  } while (!kbhit());
  getch();


  delete screen;
  crt_restoreVideoMode();
}