#ifndef W3D_DECL
  #include <w3d\w3d_decl.h>
#endif
#ifdef W3D_WORLD
  #error W3d world already included.
#endif
#define W3D_WORLD

class world3D:public wld_p {
  private:
  object3D *objH;

  public:
  char *name;
  int cObjects;
  object3Ds *obj;

  world3D();                     // inizializza mondo vuoto
  world3D(object3D *objHpnt, char* worldName);
  void setName(char* worldName);
  char *getName();
  object3Ds *getObj(int index);
  void addObj(object3Ds newObj);
  void delObj(int index);
  void draw();
  //object3D getObj(char* objName);

};

world3D::world3D() {                     // inizializza mondo vuoto
    sizeX = 320;
    sizeY = 200;
    sizeZ = 320;
    meX = 0;
    meY = 0;
    meZ = sizeZ/2;
    cObjects = 0;
    obj = NULL;
    name = (char*)malloc(1);
    *name = 0;
  }

world3D::world3D(object3D *objHpnt, char* worldName) {
    objH = objHpnt;
    sizeX = 320;
    sizeY = 200;
    sizeZ = 320;
    meX = 0;
    meY = 0;
    meZ = sizeZ/2;
    cObjects = 0;
    obj = NULL;
    name = (char*)malloc(1);
    *name = 0;
    setName(worldName);
  }

void world3D::setName(char* worldName) {
  name = (char*)realloc((void*)*name,strlen(worldName)+1);
  //if (name == NULL) { printf("memory error\n"); }
  name = worldName;
}

char *world3D::getName() {
  return(name);
}

object3Ds *world3D::getObj(int index) {
  int i;
  object3Ds *lastpnt;
  if (index >= cObjects) return(NULL);
  lastpnt = obj;
  for (i=0;i<index;i++) {
    asm {
      PUSH SI
      MOV  SI, lastpnt
      ADD  SI, SIZE_OBJ
      MOV  AX, DS:[SI][0x04]  // WARNING!!
      MOV  lastpnt, AX
      POP  SI
    }
  }
  return(lastpnt);
}

void world3D::addObj(object3Ds newObj) {
  object3Ds *prevN, *nextN;
  object3Ds *newpnt = (object3Ds *)malloc(sizeof(object3Ds)+8);
  if (!cObjects) {
    prevN = NULL;
    obj = newpnt;
  } else {
    prevN = getObj(cObjects-1);
    asm {
      PUSH SI
      MOV  SI, prevN
      ADD  SI, SIZE_OBJ
      MOV  AX, newpnt
      MOV  DS:[SI][0x04], AX
      POP  SI
    }
  }
  nextN = NULL;
  asm {
    PUSH SI
    MOV  SI, newpnt
    ADD  SI, SIZE_OBJ
    MOV  AX, prevN
    MOV  DS:[SI], AX
    MOV  AX, nextN
    MOV  DS:[SI][0x04], AX
    POP  SI
  }
  // SISTEMARE!!
  newpnt->cNodes = newObj.cNodes;
  newpnt->cEdges = newObj.cEdges;
  newpnt->nodes = newObj.nodes;
  newpnt->edges = newObj.edges;
  cObjects++;
}

void world3D::delObj(int index) {
  if (index >= cObjects) return;
  object3Ds *prevO, *thisO, *nextO;
  thisO = getObj(index);
  asm {
    PUSH SI
    MOV  SI, thisO
    ADD  SI, SIZE_OBJ
    MOV  AX, DS:[SI]
    MOV  prevO, AX
    MOV  AX, DS:[SI][0x04]
    MOV  nextO, AX
    POP  SI
  }
  if (prevO)
    asm {
      PUSH SI
      MOV  SI, prevO
      ADD  SI, SIZE_OBJ
      MOV  AX, nextO
      MOV  DS:[SI][0x04], AX
      POP  SI
    }
  else obj = nextO;
  if (nextO)
    asm {
      PUSH SI
      MOV  SI, nextO
      ADD  SI, SIZE_OBJ
      MOV  AX, prevO
      MOV  DS:[SI], AX
      POP  SI
    }
  free(thisO);
  cObjects--;
}

void world3D::draw() {
  int i;
  for (i=0;i<cObjects;i++) {
    objH->draw(getObj(i));
  }
}

/*object3D world3D::getObj(char* objName) {
    //not supported
  }
*/
