/*
editlev
*/

#include <conio.h>
#include <stdio.h>
//#include <graphics.h>
#include "../mouse/mouse.h"

#define  CELL_SIZE  10
#define  LEFT_SIZE  (12*3)
#define  UP_SIZE    (9+4)
typedef int ERRPROC(int, int);
typedef ERRPROC *PERRPROC;

#include "vga2.h"
#include "vgapal2.h"
#include "vgafont.h"
#include "vgawin.h"
#include "labyr.h"
#include "items.h"
#include "myfont.h"

const int cellSize = 20;

VirtualScreen *mainScr = 0;
pal256 mainPal;
Font *mainFont = 0;
Labyrinth *lab = 0;
short posX, posY;
char useMouse = 0;

char fileExists(char *name) {
  char ex;
  FILE *f = fopen(name, "r");
  ex = (f != 0);
  if (ex) fclose(f);
  return(ex);
}

void exitFunc(int code) {
  crt_restoreVideoMode();
  if (lab != 0) delete lab;
  if (mainScr) delete mainScr;
  if (mainFont) delete mainFont;
  exit(code);
}

void initPal() {
  pal_inAll(&mainPal);
  pal_setGradient(&mainPal, 0x10,0x1F, 0,0,0, 63,63,63);  // white
  pal_setGradient(&mainPal, 0x20,0x27, 0,0,0, 0,0,63);    // blue
  pal_setGradient(&mainPal, 0x28,0x2F, 0,0,63, 63,63,63);
  pal_setGradient(&mainPal, 0x30,0x37, 0,0,0, 0,63,0);    // green
  pal_setGradient(&mainPal, 0x38,0x3F, 0,63,0, 63,63,63);
  pal_setGradient(&mainPal, 0x40,0x47, 0,0,0, 63,0,0);    // red
  pal_setGradient(&mainPal, 0x48,0x4F, 63,0,0, 63,63,63);
  pal_setGradient(&mainPal, 0x50,0x57, 0,0,0, 0,63,63);   // cyan
  pal_setGradient(&mainPal, 0x58,0x5F, 0,63,63, 63,63,63);
  pal_setGradient(&mainPal, 0x60,0x67, 0,0,0, 63,63,0);   // yellow
  pal_setGradient(&mainPal, 0x68,0x6F, 63,63,0, 63,63,63);
  pal_setGradient(&mainPal, 0x70,0x77, 0,0,0, 63,0,63);   // magenta
  pal_setGradient(&mainPal, 0x78,0x7F, 63,0,63, 63,63,63);
  pal_setGradient(&mainPal, 0x80,0x87, 0,0,0, 37,19,18);  // brown
  pal_setGradient(&mainPal, 0x88,0x8F, 37,19,18, 63,63,63);
  pal_outAll(&mainPal);
}

void drawItem(int x, int y, const BYTE *ptr, char reverse) {
  int i,j;
  BYTE b;
  for (j=0; j<CELL_SIZE; j++) {
    for (i=0; i<CELL_SIZE; i++) {
      switch (reverse) {
        case 1:
          b = *(ptr+j*CELL_SIZE+CELL_SIZE-i-1);
          break;
        case 2:
          b = *(ptr+(CELL_SIZE-j-1)*CELL_SIZE+CELL_SIZE+i);
          break;
        default: b = *(ptr+j*CELL_SIZE+i);
      }
      if (b != 0) mainScr->putpixel(x+i,y+j, b);
    }
  }
}

void drawLeft() {
  char buff[50];
  int i,j, hup, cell, stx,sty;

  cell = LEFT_SIZE/3;
  hup = UP_SIZE;

  mainScr->frect(0,0,cell*3,VGA_MAXY, 0x52);
  mainScr->frect(0,0,VGA_MAXX,hup, 0x52);
  mainScr->rect(0,hup,cell*3,VGA_MAXY, 0x54);
  mainScr->rect(0,0,VGA_MAXX,hup, 0x54);
  mainScr->line(cell,hup,cell,cell*14, 0x54);      // vert
  mainScr->line(cell*2,hup,cell*2,cell*14, 0x54);  // vert
  for (i=0; i<16; i++) mainScr->line(0,hup+i*cell,cell*3,hup+i*cell, 0x54);
  mainFont->setTextColor(0x56);
  mainFont->print(2,2, lab->getName());
  sprintf(buff, "Dimensioni: %i x %i", lab->getWidth(),lab->getHeight());
  mainFont->print(160,2, buff);

  stx = (cell-mainFont->getCharWidth('A'))>>1;
  sty = ((cell-mainFont->getCharHeight('A'))>>1)+hup+1;
  mainFont->print(stx+0*cell,sty+0*cell, "N");
  mainFont->print(stx+1*cell,sty+0*cell, "D");
  mainFont->print(stx+2*cell,sty+0*cell, "P");
  mainFont->print(stx+1*cell,sty+10*cell, "X");
  mainFont->print(stx+0*cell-1,sty+13*cell, "Salva");
  mainFont->print(stx+0*cell-1,sty+14*cell, "Esci");

  stx = (cell-CELL_SIZE)>>1;
  sty = ((cell-CELL_SIZE)>>1)+hup;
  for (j=2; j<8; j++) {
    for (i=0; i<2; i++) {
      //mainScr->rect(stx+i*cell,sty+j*cell, stx+i*cell+CELL_SIZE,sty+j*cell+CELL_SIZE, 8);
    }
  }
  mainScr->line(stx+0*cell+CELL_SIZE,sty+2*cell, stx+0*cell+CELL_SIZE,sty+2*cell+CELL_SIZE, 15);
  mainScr->line(stx+0*cell+CELL_SIZE-1,sty+2*cell, stx+0*cell+CELL_SIZE-1,sty+2*cell+CELL_SIZE, 15);
  mainScr->line(stx+1*cell,sty+2*cell, stx+1*cell+CELL_SIZE,sty+2*cell, 15);
  mainScr->line(stx+1*cell,sty+2*cell+1, stx+1*cell+CELL_SIZE,sty+2*cell+1, 15);
  mainScr->line(stx+0*cell,sty+3*cell, stx+0*cell,sty+3*cell+CELL_SIZE, 15);
  mainScr->line(stx+0*cell+1,sty+3*cell, stx+0*cell+1,sty+3*cell+CELL_SIZE, 15);
  mainScr->line(stx+1*cell,sty+3*cell+CELL_SIZE, stx+1*cell+CELL_SIZE,sty+3*cell+CELL_SIZE, 15);
  mainScr->line(stx+1*cell,sty+3*cell+CELL_SIZE-1, stx+1*cell+CELL_SIZE,sty+3*cell+CELL_SIZE-1, 15);
  // TODO!  muro contorno (5)
  drawItem(stx+0*cell,sty+4*cell, item_1waye,0);
  drawItem(stx+1*cell,sty+4*cell, item_1waye,1);
  drawItem(stx+0*cell,sty+5*cell, item_1wayn,0);
  drawItem(stx+1*cell,sty+5*cell, item_1wayn,2);
  drawItem(stx+0*cell,sty+6*cell, item_life,0);
  drawItem(stx+1*cell,sty+6*cell, item_death,0);
  drawItem(stx+2*cell,sty+6*cell, item_endlevel,0);
  drawItem(stx+0*cell,sty+7*cell, item_msg,0);
  drawItem(stx+1*cell,sty+7*cell, item_light,0);
  drawItem(stx+0*cell,sty+8*cell, item_potionr,0);
  drawItem(stx+1*cell,sty+8*cell, item_potiong,0);
  drawItem(stx+2*cell,sty+8*cell, item_potionb,0);
}

void drawLab() {
  int i,j, centerx, centery, stx, sty, ex,ey;
  char foundmsg = 0, buff[10];

  centerx = ((VGA_WIDTH-LEFT_SIZE)>>1)+LEFT_SIZE;
  centery = VGA_HEIGHT>>1;
  stx = centerx-posX*CELL_SIZE;
  sty = centery-posY*CELL_SIZE;
  ex = centerx+(lab->getWidth()-posX)*CELL_SIZE;
  ey = centery+(lab->getHeight()-posY)*CELL_SIZE;

  mainScr->frect(LEFT_SIZE+1,UP_SIZE+1,VGA_MAXX,VGA_MAXY, 0);
  for (j=0; j<=lab->getHeight(); j++) { // horiz line
    if (sty+j*CELL_SIZE <= UP_SIZE) continue;
    mainScr->line(max(stx,LEFT_SIZE+1), sty+j*CELL_SIZE, ex, sty+j*CELL_SIZE, 8);
  }
  for (j=0; j<=lab->getWidth(); j++) { // vert line
    if (stx+j*CELL_SIZE <= LEFT_SIZE) continue;
    mainScr->line(stx+j*CELL_SIZE, max(sty,UP_SIZE+1), stx+j*CELL_SIZE, ey, 8);
  }
  i = (stx+lab->getStartX()*CELL_SIZE+(CELL_SIZE>>1));
  j = (sty+lab->getStartY()*CELL_SIZE+(CELL_SIZE>>1));
  if ((i-CELL_SIZE/2 > LEFT_SIZE)&&(j-CELL_SIZE/2 > UP_SIZE)) {
    mainScr->fcircle(i,j, (CELL_SIZE>>1)-2, 2);
    mainScr->circle(i,j, (CELL_SIZE>>1)-2, 15);
  }
  for (j=0; j<lab->getHeight(); j++) {
    for (i=0; i<lab->getWidth(); i++) {
      char w = lab->getWall(i,j);
      int cx, cy;
      cx = stx+i*CELL_SIZE;
      cy = sty+j*CELL_SIZE;
      if (cx <= LEFT_SIZE) continue;
      if (cy <= UP_SIZE) continue;
      if ((w & LABY_WALL_E) == LABY_WALL_E) mainScr->line(cx+CELL_SIZE-1, cy, cx+CELL_SIZE-1, cy+CELL_SIZE-1, 15);
      if ((w & LABY_WALL_N) == LABY_WALL_N) mainScr->line(cx, cy, cx+CELL_SIZE-1, cy, 15);
      if ((w & LABY_WALL_W) == LABY_WALL_W) mainScr->line(cx, cy, cx, cy+CELL_SIZE-1, 15);
      if ((w & LABY_WALL_S) == LABY_WALL_S) mainScr->line(cx, cy+CELL_SIZE-1, cx+CELL_SIZE-1, cy+CELL_SIZE-1, 15);
      w = lab->getItem(i,j);
      switch (w) {
        case LABY_ITEM_LIFE: drawItem(cx, cy, item_life,0); break;
        case LABY_ITEM_DEATH: drawItem(cx, cy, item_death,0); break;
        case LABY_ITEM_ENDLEV: drawItem(cx, cy, item_endlevel,0); break;
        case LABY_ITEM_MESSAGE:
          drawItem(cx, cy, item_msg,0);
          if ((posX == i)&&(posY == j)) foundmsg = 1;
          break;
        case LABY_ITEM_LIGHT: drawItem(cx, cy, item_light,0); break;
        case LABY_ITEM_POTIONR: drawItem(cx, cy, item_potionr,0); break;
        case LABY_ITEM_POTIONG: drawItem(cx, cy, item_potiong,0); break;
        case LABY_ITEM_POTIONB: drawItem(cx, cy, item_potionb,0); break;
        case LABY_ITEM_ONEWAY_E: drawItem(cx, cy, item_1waye,0); break;
        case LABY_ITEM_ONEWAY_N: drawItem(cx, cy, item_1wayn,0); break;
        case LABY_ITEM_ONEWAY_W: drawItem(cx, cy, item_1waye,1); break;
        case LABY_ITEM_ONEWAY_S: drawItem(cx, cy, item_1wayn,2); break;
        default:
          if ((w >= LABY_ITEM_TELEPORT)&&(w < LABY_ITEM_TELEPORT+16)) {
            drawItem(cx, cy, item_tport,0);
            itoa(w-LABY_ITEM_TELEPORT,buff,10);
            mainFont->setTextColor(14);
            mainFont->print(cx+2,cy+1, buff);
          }
          break;
      }
    }
  }
  mainScr->rect(centerx, centery, centerx+CELL_SIZE, centery+CELL_SIZE, 3);
  if (foundmsg) {
    int lin = ((strlen(lab->getMessage(posX, posY))*(mainFont->getCharWidth('A')+mainFont->spacing))/(VGA_WIDTH-LEFT_SIZE) + 2);
    int sizY = 1+mainFont->getCharHeight('A')*lin;
    mainScr->frect(LEFT_SIZE+1,VGA_MAXY-sizY, VGA_MAXX, VGA_MAXY, 0x52);
    mainScr->rect(LEFT_SIZE+1,VGA_MAXY-sizY, VGA_MAXX, VGA_MAXY, 0x54);
    mainFont->setTextColor(0x54);
    mainFont->printRect(LEFT_SIZE+3,VGA_MAXY-sizY+2, VGA_MAXX-2, VGA_MAXY-2, lab->getMessage(posX, posY));
  }
}

void setName() {
  char name[50];
  Window *namewin = new Window(mainScr, 0,0, 250, 30);
  namewin->setColors(0x54,0x52);
  namewin->setCenter();
  namewin->show(1);
  mainFont->setTextColor(0x54);
  mainFont->setBackColor(0x52);
  mainFont->print(namewin->getX1()+2, namewin->getY1()+2, "Inserisci il nome del livello:");
  mainFont->readLine(namewin->getX1()+2, namewin->getY1()+2+mainFont->getCharHeight('A'), 30, name);
  delete namewin;
  lab->setName(name);
  drawLeft();
}

void setSize() {
  char name[10];
  int nx,ny;
  Window *sizewin = new Window(mainScr, 0,0, 150, 40);
  sizewin->setColors(0x54,0x52);
  sizewin->setCenter();
  sizewin->show(1);
  mainFont->setTextColor(0x54);
  mainFont->setBackColor(0x52);
  mainFont->print(sizewin->getX1()+2, sizewin->getY1()+2, "Nuova larghezza:");
  mainFont->readLine(sizewin->getX1()+2+80, sizewin->getY1()+2, 8, name);
  nx = atoi(name);
  mainFont->print(sizewin->getX1()+2, sizewin->getY1()+2+9, "Nuova altezza:");
  mainFont->readLine(sizewin->getX1()+2+80, sizewin->getY1()+2+9, 8, name);
  ny = atoi(name);
  delete sizewin;
  if ((nx > 0)&&(ny > 0)&&(nx < 300)&&(ny < 300)) {
    lab->resize(nx,ny);
    if (posX >= lab->getWidth()) posX = lab->getWidth()-1;
    if (posY >= lab->getHeight()) posY = lab->getHeight()-1;
  }
  drawLeft();
}

void saveLab() {
  /*int nx,ny, size = imagesize(100,200, getmaxx()-100, 300);
  char *buff = (char *)malloc(size);
  char fil[100];
  getimage(100,200,getmaxx()-100, 300, (void *)buff);
  setfillstyle(SOLID_FILL, getbkcolor());
  bar(101,201, getmaxx()-101, 299);
  rectangle(100,200,getmaxx()-100, 300);

  outtextxy(120, 220, "Nome del file: ");
  outtextxy(120, 250, "Se il file esiste, verr sovrascritto.");
  intextxy(240,220, fil);
  lab->writeToFile(fil);

  putimage(100,200, (void *)buff, COPY_PUT);
  free(buff);
  drawLeft();
  drawLab();*/
}

void setTeleport() {
  char name[10];
  int nt;
  Window *telewin = new Window(mainScr, 0,0, 150, 30);
  telewin->setColors(0x54,0x52);
  telewin->setCenter();
  telewin->show(1);
  mainFont->setTextColor(0x54);
  mainFont->setBackColor(0x52);
  mainFont->print(telewin->getX1()+2, telewin->getY1()+2, "Numero teletrasporto:");
  mainFont->readLine(telewin->getX1()+2+100, telewin->getY1()+2, 8, name);
  nt = atoi(name);
  delete telewin;
  lab->setItem(posX, posY, LABY_ITEM_TELEPORT | min(nt, 0x0F));
}

void setMsg() {
  char name[200];
  Window *namewin = new Window(mainScr, 0,0, 250, 50);
  namewin->setColors(0x54,0x52);
  namewin->setCenter();
  namewin->show(1);
  mainFont->setTextColor(0x54);
  mainFont->setBackColor(0x52);
  mainFont->print(namewin->getX1()+2, namewin->getY1()+2, "Testo del messaggio:");
  mainFont->readLine(namewin->getX1()+2, namewin->getY1()+2+mainFont->getCharHeight('A'), 200, name);
  delete namewin;
  lab->addMessage(posX,posY,name);
}


void editLevel() {
  char key, quit = 0;
  char buff[50];
  int i;

  if (kbhit()) getch();

  mainScr = new VirtualScreen();
  mainScr->clear(0);
  mainFont = new Font(mainScr);
  for (i=0; i<CHAR_COUNT; i++) mainFont->addChar(fnts[i]);
  crt_setVideoMode(0x13);
  initPal();

  useMouse = mouse_reset();
  posX = lab->getWidth()>>1;
  posY = lab->getHeight()>>1;
  drawLeft();
  drawLab();
  if (useMouse) mouse_show();
  do {
    mouse_getStatus();

    sprintf(buff, "mouse: %i %i",mouseInfo.xPos, mouseInfo.yPos);
    mainFont->setTextColor(14);
    mainScr->frect(LEFT_SIZE+2,UP_SIZE+2, 200,UP_SIZE+15, 0);
    mainFont->print(LEFT_SIZE+2,UP_SIZE+2,buff);

    if (mouseInfo.xPos > VGA_WIDTH-5) {
      //if (++posX >= lab->getWidth()) posX = lab->getWidth()-1;
      //drawLab();
      //delay(50);
    }
    if (mouseInfo.xPos < 5) {
      if (--posX < 0) posX = 0;
      drawLab();
      delay(50);
    }
    if (mouseInfo.yPos > VGA_HEIGHT-5) {
      if (++posY >= lab->getHeight()) posY = lab->getHeight()-1;
      drawLab();
      delay(50);
    }
    if (mouseInfo.yPos < 5) {
      if (--posY < 0) posY = 0;
      drawLab();
      delay(50);
    }
    if (mouseInfo.leftButton) {
      if (mouseInfo.xPos > 150) {
        /*int centerx = (getmaxx()-151)>>1;
        int centery = getmaxy()>>1;

        int stx = centerx-(posX)*cellSize+150;
        int sty = centery-(posY)*cellSize;

        posX = (mouseInfo.xPos-stx)/cellSize;
        posY = (mouseInfo.yPos-sty)/cellSize;
        posX = max(0,min(posX,lab->getWidth()-1));
        posY = max(0,min(posY,lab->getHeight()-1));
        //drawLab();
        mouse_setPos(centerx+150+cellSize/2,centery+cellSize/2);
        delay(100);*/
      }
    }
    if (kbhit()) {
      key = getch();
      switch (key) {
        case 0x1B:
  	  //quit = 1; //disabled
          break;
        case 'n': setName(); break;
        case 'd': setSize(); break;
        case 'p':
          lab->setStart(posX,posY);
          break;
        case '1': //E
      	  lab->setWall(posX, posY, lab->getWall(posX, posY)^LABY_WALL_E);
          if (posX < lab->getWidth()-1) lab->setWall(posX+1, posY, lab->getWall(posX+1, posY)^LABY_WALL_W);
  	  break;
        case '2': //N
    	  lab->setWall(posX, posY, lab->getWall(posX, posY)^LABY_WALL_N);
     	  if (posY > 0) lab->setWall(posX, posY-1, lab->getWall(posX, posY-1)^LABY_WALL_S);
	  break;
        case '3': //O
	  lab->setWall(posX, posY, lab->getWall(posX, posY)^LABY_WALL_W);
	  if (posX > 0) lab->setWall(posX-1, posY, lab->getWall(posX-1, posY)^LABY_WALL_E);
	  break;
        case '4': //S
	  lab->setWall(posX, posY, lab->getWall(posX, posY)^LABY_WALL_S);
	  if (posY < lab->getHeight()-1) lab->setWall(posX, posY+1, lab->getWall(posX, posY+1)^LABY_WALL_N);
	  break;
        case '5':
	  for (i=0; i<lab->getWidth(); i++) {
	    lab->setWall(i, 0, lab->getWall(i,0)^LABY_WALL_N);
	    lab->setWall(i, lab->getHeight()-1, lab->getWall(i,lab->getHeight()-1)^LABY_WALL_S);
	  }
  	  for (i=0; i<lab->getHeight(); i++) {
   	    lab->setWall(0, i, lab->getWall(0,i)^LABY_WALL_W);
	    lab->setWall(lab->getWidth()-1,i, lab->getWall(lab->getWidth()-1, i)^LABY_WALL_E);
	  }
	  break;
        case '6': lab->setItem(posX, posY, LABY_ITEM_ONEWAY_E); break;
        case '7': lab->setItem(posX, posY, LABY_ITEM_ONEWAY_N); break;
        case '8': lab->setItem(posX, posY, LABY_ITEM_ONEWAY_W); break;
        case '9': lab->setItem(posX, posY, LABY_ITEM_ONEWAY_S); break;
        case 'v': lab->setItem(posX, posY, LABY_ITEM_LIFE); break;
        case 'm': lab->setItem(posX, posY, LABY_ITEM_DEATH); break;
        case 'f': lab->setItem(posX, posY, LABY_ITEM_ENDLEV); break;
        case 'q': lab->setItem(posX, posY, LABY_ITEM_POTIONR); break;
        case 'a': lab->setItem(posX, posY, LABY_ITEM_POTIONG); break;
        case 'z': lab->setItem(posX, posY, LABY_ITEM_POTIONB); break;
        case 't': setTeleport(); break;
        case 's': setMsg(); break;
        case 'l': lab->setItem(posX, posY, LABY_ITEM_LIGHT); break;
        case 'x': lab->setItem(posX, posY, LABY_ITEM_NULL); break;
        case 0:
	  key = getch();
	  switch (key) {
	    case 60: // F2
	      saveLab();
	      break;
	    case 61: // F3
	      quit = 1;
	      break;
	    case 75: //sx
	      if (--posX < 0) posX = 0;
	      break;
	    case 77: //dx
	      if (++posX >= lab->getWidth()) posX = lab->getWidth()-1;
	      break;
	    case 72: //up
	      if (--posY < 0) posY = 0;
	      break;
	    case 80: //down
	      if (++posY >= lab->getHeight()) posY = lab->getHeight()-1;
	      break;
	  }
      }
      drawLab();
    }

    mouse_hide();
    mainScr->show();
    mouse_show();
    delay(50);
  } while (!quit);
}

void main(int argc, char *argv[]) {
  char key;
  char name[100];

  crt_init();
  lab = new Labyrinth();

  if (argc <= 1) {
    printf("Vuoi aprire o creare? (a,c) ");
    key = getche();
    printf("\n");
  } else {
    key = 'a';
    strcpy(name, argv[1]);
  }
  switch (key) {
    case 'a': {
      if (argc <= 1) {
        printf("Nome del file: ");
        gets(name);
      }
      if (name[strlen(name)-4] != '.') strcat(name, ".lev");
      if (!fileExists(name)) {
        printf("non esiste");
        exitFunc(1);
      }
      lab->readFromFile(name);
      break;
    }
    case 'c': {
      int x,y;
      char buff[100];
      printf("Larghezza: ");
      cscanf("%i", &x); printf("\n");
      printf("Altezza: ");
      cscanf("%i", &y); printf("\n");
      x = max(1,min(x,100));
      y = max(1,min(y,100));
      lab->create(x,y);
      printf("Nome: ");
      gets(buff); printf("\n");
      lab->setName(buff);
      break;
    }
    default:
      exitFunc(0);
      break;
  }

  editLevel();
  exitFunc(0);
}