; compile with a86

LIGHT_MAXRADIUS  EQU  150  ; same as in laby.cpp

PUBLIC _dist, _dist2, _getLightRad
EXTRN _lightDeltaTab:DWORD, _lightRadius:WORD


.CODE

_dist PROC NEAR  ; computes sqrt(x*x+y*y) using floating point instructions
y  EQU [bp+4]
x  EQU [bp+6]
  push  bp
  mov   bp, sp
  sub   sp, 4
  mov   ax, word ptr x
  imul  ax
  mov   word ptr [bp-4], ax
  mov   word ptr [bp-2], dx
  mov   ax, word ptr y
  imul  ax
  add   word ptr [bp-4], ax
  adc   word ptr [bp-2], dx
  finit
  fild  dword ptr [bp-4]
  fsqrt
  fist  word ptr [bp-4]
  mov   ax, word ptr [bp-4]
  mov   sp, bp
  pop   bp
  ret
_dist ENDP


_dist2 PROC NEAR  ; computes sqrt(x*x+y*y) using 32bit instructions
y  EQU [bp+4]
x  EQU [bp+6]
  push  bp
  mov   bp, sp
  push  bx
  push  dx
  DB 066,00F,0B7,046,006  ; movzx eax, word ptr [bp+6]
  DB 066
  imul  ax
  DB 066
  mov   bx, ax
  DB 066,00F,0B7,046,004  ; movzx eax, word ptr [bp+4]
  DB 066
  imul  ax
  DB 066
  add   ax, bx
  db 066
  push  ax
  call  _sqrt_i4
  ;add   sp, 4
  pop   dx
  pop   bx
  mov   sp, bp
  pop   bp
  ret
_dist2 ENDP

_sqrt_i4 PROC NEAR
n  EQU [bp+4]
  push  bp
  mov   bp, sp
  push  di
  DB 066
  xor   di, di
  DB 066
  mov   bx, word ptr n
  DB 066
  cmp   bx, 0
  jle   endfunc
  DB 066
  xor   dx, dx
  mov   cl, 16
  loop1:
    DB 066
    rol   bx,2
    mov   al, bl
    and   al, 3
    DB 066
    shl   dx,2
    or    dl, al
    DB 066
    shl   di, 1
    DB 066
    mov   ax, di
    DB 066
    shl   ax, 1
    or    al, 1
    DB 066
    cmp   ax, dx
    ja    zero
    DB 066
    sub   dx, ax
    or    di, 1
  zero:
  dec   cl
  jnz   loop1
  endfunc:
  mov   ax, di
  DB 066
  shr   di, 16
  mov   dx, di
  pop   di
  pop   bp
  ret
_sqrt_i4 ENDP


_getLightRad:
; return( *(lightDeltaTab+((long)y*LIGHT_MAXRADIUS/lightRadius)*LIGHT_MAXRADIUS+(long)x*LIGHT_MAXRADIUS/lightRadius) );
y  EQU [bp+4]
x  EQU [bp+6]
  push  bp
  mov   bp, sp
  push  es
  push  di
  les   di, _lightDeltaTab
  mov   ax, y
  mov   bx, LIGHT_MAXRADIUS
  mul   bx
  div   _lightRadius
  mul   bx
  push  ax
  mov   ax, x
  mul   bx
  div   _lightRadius
  pop   bx
  add   bx, ax
  mov  al, es:[di+bx]
  pop   di
  pop   es
  pop   bp
  ret