#define STW_MAXLINES   SCORE_MAXITEMS+2
#define DELAY        10

int stw_lines;
char *stw_text[STW_MAXLINES];

void initStwars();
void doneStwars();
void doStars();
void doText();

void showScore() {
  int i,it;
  PSCORE ts;
  char buff[50];
  //showMessage("Spiacente, ma i punteggi non sono ancora disponibili.",0);
  scores = new TopScores();
  scores->readItems();

  it = scores->getItems();
  stw_lines = it+2;
  stw_text[0] = strdup("Masters of Laby");
  stw_text[1] = strdup("");
  for (i=0; i<it; i++) {
    ts = scores->getItem(i);
    sprintf(buff, "%-13s %2i", ts->name, ts->level);
    stw_text[it-i+1] = strdup(buff);
  }
  initStwars();

  do {
    doStars();
    doText();
    mainScr->show();
    mainScr->clear(0);
    delay(DELAY);
  } while (!kbhit()); getch();

  doneStwars();
  for (i=0; i<stw_lines; i++) free(stw_text[i]);
  delete scores;
  scores = 0;
}


#define SPEED_STARS   2
#define SPEED_TEXT    1
#define MAXSTARS    300
#define SIZEZ       500

#define SHAPE_XT     160   //        _         (xtop,ytop)
#define SHAPE_YT       0   //       / \
#define SHAPE_YM      50   //      /___\       (ym)
#define SHAPE_YB     199   //     /     \
#define SHAPE_XB1      0   //    /       \
#define SHAPE_XB2    319   //   /_________\    (yb)
                           // (xb1)     (xb2)

int textLen[STW_MAXLINES];
int maxTextLen = 0, counter = 0;

typedef struct { // linked with to2D()
  int x,y,z;
} POINT, *PPOINT;

pal256 starPal;
POINT stars[MAXSTARS];
BYTE far *starScr;
BYTE *hTab = 0;
int far *sTab = 0;

void to2D(POINT p, int *x, int *y) {
  //*x = (long)p.x*(p.z+SIZEZ/2)/SIZEZ;
  //*y = (long)p.y*(p.z+SIZEZ/2)/SIZEZ;
  asm {
    //push  si
    lea   si, p
    mov   cx, SIZEZ
    mov   ax, [si+4] // load z
    add   ax, SIZEZ/2
    push  ax
    imul  word [si+0] // mul x
    idiv  cx
    mov   bx, x
    mov   [bx], ax
    pop   ax
    imul  word [si+2] // mul y
    idiv  cx
    mov   bx, y
    mov   [bx], ax
    //pop   si
  }
}

void createStar(int i) {
  int siz;
  stars[i].z = -rand()%(SIZEZ/2);
  siz = 1000-stars[i].z*2;
  stars[i].x = rand()%siz-siz/2;
  stars[i].y = rand()%siz-siz/2;
}

void initStwars() {
  int i;
  mainScr->clear(0);
  mainScr->show();
  pal_setGradient(&starPal, 0x10,0x2F, 0,0,0, 63,63,63);  // white
  pal_setGradient(&starPal, 0x30,0x40, 0,2,2, 10,30,30);  // textcolor
  pal_setGradient(&starPal, 0x40,0x8F, 10,30,30, 10,63,53);
  pal_outAll(&starPal);
  counter = SHAPE_YB;
  for (i=0; i<MAXSTARS; i++) createStar(i);
  for (i=0; i<stw_lines; i++) {
    textLen[i] = strlen(stw_text[i]);
    if (textLen[i] > maxTextLen) maxTextLen = textLen[i];
  }
  starScr = (BYTE far *)farmalloc((long)maxTextLen*8*17);
}

void doneStwars() {
  if (starScr != 0) farfree(starScr); starScr = 0;
  if (hTab != 0) free(hTab); hTab = 0;
  if (sTab != 0) farfree(sTab); sTab = 0;
  mainScr->clear(0);
  mainScr->show();
  pal_outAll(&mainPal);
  counter = 0;
}

void doStars() {
  int i, x,y;
  BYTE color;
  for (i=0; i<MAXSTARS; i++) {
    stars[i].z += SPEED_STARS+min((stars[i].z+SIZEZ/2),SIZEZ)*4/SIZEZ;
    color = min(stars[i].z+SIZEZ/2,SIZEZ-1)*32/SIZEZ+0x10;
    to2D(stars[i], &x, &y);
    x += 160;  y = 100-y;
    if ((x < 0)||(y < 0)||(x > VGA_MAXX)||(y > VGA_MAXY)) createStar(i);
    else mainScr->putPixel(x,y, color);
  }
}

int calcHeight(int y) { // SHAPE_YM <= y <= SHAPE_YB
  if (hTab == 0) { // precalc
    hTab = (BYTE*)malloc((SHAPE_YB-SHAPE_YM+1));
    if (hTab == 0) return(15*y/(SHAPE_YB>>2-SHAPE_YT));
    for (int i=SHAPE_YM; i<=SHAPE_YB; i++) {
      hTab[i-SHAPE_YM] = 15*i/(SHAPE_YB>>2-SHAPE_YT);
    }
  }
  return(hTab[y-SHAPE_YM]);
}

void calcS(int y, int j, int *s1, int *s2) { // SHAPE_YT <= y <= SHAPE_YB
  static int maxh = calcHeight(SHAPE_YB);
  int x1,x2,x3,x4;

  if (sTab == 0) {
    sTab = (int far *)farmalloc((long)(SHAPE_YB-SHAPE_YT+17)*2*maxh*sizeof(int));
    if (sTab == 0) {
      *s1 = 0;
      *s2 = 160;
      return;
    }
    for (int k=SHAPE_YT; k<=SHAPE_YB+16; k++) {
      x1 = SHAPE_XT-(long)(k-SHAPE_YT)*(SHAPE_XT-SHAPE_XB1)/(SHAPE_YB-SHAPE_YT);
      x2 = SHAPE_XT+(long)(k-SHAPE_YT)*(SHAPE_XB2-SHAPE_XT)/(SHAPE_YB-SHAPE_YT);
      x3 = SHAPE_XT-(long)(16+k-SHAPE_YT)*(SHAPE_XT-SHAPE_XB1)/(SHAPE_YB-SHAPE_YT);
      x4 = SHAPE_XT+(long)(16+k-SHAPE_YT)*(SHAPE_XB2-SHAPE_XT)/(SHAPE_YB-SHAPE_YT);
      for (int i=0; i<maxh; i++) {
        *(sTab+(k-SHAPE_YT)*maxh*2+i*2+0) = max(x1-(x1-x3+1)*(i+1)/16, 0);
        *(sTab+(k-SHAPE_YT)*maxh*2+i*2+1) = min(x2+(x4-x2+1)*(i+1)/16, VGA_MAXX);
      }
    }
  }
  *s1 = *(sTab+((y-SHAPE_YT)*maxh+j)*2+0);
  *s2 = *(sTab+((y-SHAPE_YT)*maxh+j)*2+1);
}

BYTE calcCol(int y) { // SHAPE_YM <= y <= SHAPE_YB
  static BYTE *colTab = 0;
  if (colTab == 0) {
    colTab = (BYTE*)malloc((SHAPE_YB-SHAPE_YM+1)*sizeof(BYTE));
    if (colTab == 0) return( (y-SHAPE_YM)*96/(SHAPE_YB-SHAPE_YM+1)+0x30 );
    for (int j=SHAPE_YM; j<=SHAPE_YB; j++)
      colTab[j-SHAPE_YM] = (j-SHAPE_YM)*96/(SHAPE_YB-SHAPE_YM+1)+0x30;
  }
  return(colTab[y-SHAPE_YM]);
}

void fastText(int id, BYTE color) {
  int i,j,k;
  BYTE chr;
  static BYTE far *charTab = 0;
  if (charTab == 0) {
    asm {
      push  es
      push  bp
      mov   ax, 0x1130
      mov   bh, 0x06
      int   0x10
      mov   word [charTab], bp   // only if static
      mov   word [charTab+2], es
      pop   bp
      pop   es
    }
  }
  for (i=0; i<textLen[id]; i++) {
    for (j=0; j<16; j++) {
      chr = *(charTab+(BYTE)stw_text[id][i]*16+j);
      for (k=0; k<8; k++) {
	asm rol chr, 1;
	if (chr & 0x01) *(starScr+(j*maxTextLen+i)*8+k) = color;
      }
    }
  }
}

void starLine(int y, int idtext) {
  int i,j,k, s1,s2, px,py, height;
  BYTE col,col2;

  if ((y > SHAPE_YB)||(y < SHAPE_YM)) return;
  height = calcHeight(y);

  int len = textLen[idtext];
  _fmemset(starScr, 0, maxTextLen*8*17);
  fastText(idtext, 1);

  for (j=0; j<height; j++) {
    if (y+j > SHAPE_YB) break;
    if (y+j < SHAPE_YM) continue;
    calcS(y,j, &s1, &s2);
    k = s2-s1+1;
    col = calcCol(y+j);
    py = ((j+1)<<4)/height;
    for (i=s1; i<=s2; i++) {
      //px = (long)(i-s1)*len*8/(s2-s1+1);
      asm {
        mov   ax, i
        sub   ax, s1
        shl   ax, 3
        imul  len
        idiv  k
        mov   px, ax
      }
      if (*(starScr+py*maxTextLen*8+px)) mainScr->putPixel(i,y+j,col);
    }
  }
}

void doText() {
  int j,np;
  for (j=0,np=counter; j<stw_lines; j++) {
    starLine(np, j);
    np += 50;
    if (np > SHAPE_YB) break;
  }
  if (np-30 < SHAPE_YM) counter = SHAPE_YB; else counter -= SPEED_TEXT;
}
