/*
simple vga windows
*/

#ifndef VGAWIN_H
#define VGAWIN_H

#include <vga.h>

class Window {
 public:
  Window(VirtualScreen *, VGACOORD, VGACOORD, VGACOORD, VGACOORD);
  ~Window();

  VGACOORD getX1() { return(x1); }
  VGACOORD getY1() { return(y1); }
  void setColors(BYTE, BYTE);
  void setCenter();
  void show(char onoff);
 private:
  char visible;
  VGACOORD x1,y1, x2,y2;
  short width, height;
  BYTE bdrColor, backColor;

  PERRPROC errFunc;
  VirtualScreen *screen;
  BYTE far *saveBackData;
  static int errorHandler(int, int);
};

Window::Window(VirtualScreen *virscr, VGACOORD x1, VGACOORD y1, VGACOORD x2, VGACOORD y2) {
  this->x1 = x1;
  this->y1 = y1;
  this->x2 = x2;
  this->y2 = y2;
  width = x2-x1+1;
  height = y2-y1+1;
  visible = 0;
  errFunc = errorHandler;
  screen = virscr;
  if (screen == 0) errFunc(7,1);
  saveBackData = (BYTE far *)farmalloc(width*height);
  if (saveBackData == 0) errFunc(7,2);
  screen->getRect(x1,y1,x2,y2, saveBackData);
}

Window::~Window() {
  show(0);
  if (saveBackData != 0) farfree(saveBackData);
}

void Window::setColors(BYTE bdr, BYTE back) {
  bdrColor = bdr;
  backColor = back;
}

void Window::setCenter() {
  x1 = (VGA_WIDTH-width)>>1;
  x2 = x1+width-1;
  y1 = (VGA_HEIGHT-height)>>1;
  y2 = y1+height-1;
  screen->getRect(x1,y1,x2,y2, saveBackData);
}

void Window::show(char onoff) {
  if (onoff) {
    if (backColor != 0xFF) screen->fRect(x1,y1, x2,y2, backColor);
    else screen->putRect(x1,y1,x2,y2, saveBackData);
    if (bdrColor != 0xFF) {
      screen->rect(x1,y1,x2,y2, bdrColor);
    }
    visible = 1;
  } else {
    if (visible) {
      screen->putRect(x1,y1,x2,y2, saveBackData);
      visible = 0;
    }
  }
}

int Window::errorHandler(int src, int code) {
  src;
  code;
  abort();
  return(0);
}

#endif