/* LZW */
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

const int maxbits = 4;
const int maxbits2 = 8;
char text[200] = "";

char table[1<<maxbits][maxbits2+1];
int tabsize;

template <class T>
void tobin(T a) {
  int i;
  for (i=8*sizeof(T)-1; i>=0; i--) {
    printf("%i", (a>>i)&1);
  }
}

//---------------------------------------------------------------------------
class Coda {
 public:
  Coda();
  ~Coda();
  int getLength() { return(dataSize); }
  void reset() { dataPtr = 0; }
  void push(char data);
  char pop();
  void flush() { dataSize = 0; dataPtr = 0;}
  int finished() { return(dataPtr >= dataSize); }
 private:
  char *buffer;
  int bufferSize,
      dataSize;
  int dataPtr;

  void grow();
};

Coda::Coda() {
  bufferSize = 256;
  dataSize = 0;
  dataPtr = 0;
  buffer = (char*)malloc(bufferSize);
}

Coda::~Coda() {
  free(buffer);
}

void Coda::grow() {
  buffer = (char*)realloc(buffer, (bufferSize & 0xFF00)+0x100);
}

void Coda::push(char data) {
  if (dataSize == bufferSize) grow();
  *(buffer+dataSize++) = data;
}

char Coda::pop() {
  if (dataPtr == dataSize) {
    puts("No more elements.");
    return(0);
  }
  char ret = *(buffer+dataPtr++);
  if ((dataPtr & 0xFF) == 0) {
    //memmove(buffer, buffer+dataPtr, dataSize-dataPtr);
    //dataPtr = 0;
  }
  return(ret);
}

//---------------------------------------------------------------------------

void inittab() {
  strcpy(table[0], "0");
  strcpy(table[1], "1");
  tabsize = 2;
}

int isInTab(char s[maxbits2+2]) {
  for (int i=0; i<tabsize; i++) {
    if (strcmp(s, table[i]) == 0) return(i);
  }
  return(-1);
}

void printTab() {
  printf("\nTABLE\n");
  for (int i=0; i<tabsize; i++) printf("%3i: %s\n",i, table[i]);
}

void compress() {
  int i,j,pos, slen, oldpos;
  char nextbit, s[maxbits2+2], st[maxbits2+2];
  Coda *c1 = new Coda(),
       *c2 = new Coda();

  int sz = strlen(text);
  for (i=0; i<sz; i++) {
    for (j=0; j<8; j++) c1->push((text[i]>>j) & 0x01);
  }
  puts("\n[ INPUT ] - Binary (LSB first):");
  for (i=0; i<c1->getLength(); i++) printf("%i",c1->pop()); puts("");

  c1->reset();
  inittab();

  s[0] = '\0';
  slen = 0;
  for (i=0; i<c1->getLength(); i++) {
    //printTab();
    nextbit = c1->pop();
    memcpy(st, s, sizeof(s));
    st[slen] = nextbit+'0';
    st[slen+1] = '\0';
    pos = isInTab(st);
    if ((pos != -1) ) {  // exist in table
      memcpy(s, st, sizeof(s));
      slen++;
      if (slen >= maxbits2) {
        for (j=0; j<maxbits; j++) c2->push((pos>>j)&0x01);
        slen = 0;
        s[0] = '\0';
      }
      oldpos = pos;
    } else {
      if (tabsize < (1<<maxbits)) strcpy(table[tabsize++], st);
      //pos = oldpos; // ERR!
      pos = isInTab(s);
      //if (pos != oldpos) printf("Ciao castorino  %i  i: %i\n",pos,i);
      if (pos == -1) printf("error! pos: %i   %s\n",i,s);
      for (j=0; j<maxbits; j++) c2->push((pos>>j)&0x01);
      slen = 1;
      s[0] = nextbit+'0';
      s[1] = '\0';
    }

  }
  if (slen > 0) {
    pos = isInTab(s);
    for (j=0; j<maxbits; j++) c2->push((pos>>j)&0x01);
  }

  c2->reset();

  //puts("\n[ OUTPUT ] - Binary (LSB first):");
  //for (i=0; i<c2->getLength(); i++) printf("%i",c2->pop()); puts("");

  //printTab();
  //-----------------------------------
  int code, old;

  puts("\nDecompressing");
  inittab();
  c1->flush();
  c2->reset();

  for (i=0,code=0; i<maxbits; i++) code |= (c2->pop()<<i);
  for (i=0; i<strlen(table[code]); i++) c1->push(table[code][i]-'0');
  old = code;

  while (!c2->finished()) {
    for (i=0,code=0; i<maxbits; i++) code |= (c2->pop()<<i);
    strcpy(s, table[old]);
    sz = strlen(s);
    if (code < tabsize) {
      for (i=0; i<strlen(table[code]); i++) c1->push(table[code][i]-'0');
      s[sz++] = table[code][0];
      s[sz] = '\0';
      if (sz > maxbits) {
        printf("AArghh! ");
        //for (i=0; i<sz; i++) c1->push(s[i]-'0');
      }
      if (tabsize < (1<<maxbits)) strcpy(table[tabsize++], s);
    } else {
      s[sz++] = s[0];
      s[sz] = '\0';
      for (i=0; i<sz; i++) c1->push(s[i]-'0');
      if (tabsize < (1<<maxbits)) strcpy(table[tabsize++], s);
    }
    old = code;
  }

  c1->reset();
  puts("\n[ OUTPUT ] - Binary (LSB first):");
  for (i=0; i<c1->getLength(); i++) printf("%i",c1->pop()); puts("");

  c1->reset();
  puts("\n[ OUTPUT ] - Text:");
  for (i=0; i<c1->getLength()/8; i++) {
    char c = 0;
    for (j=0; j<8; j++) c |= (c1->pop()<<j);
    printf("%c", c);
  }
  puts("");


  delete c1,c2;
}

int main() {
  int i;

  clrscr();
  puts("Type something:");
  gets(text);
  /*puts("\nBinary:");
  for (i=0; i<strlen(text); i++) {
    tobin(text[i]);
    if ((i%9) != 8) putch(' ');
  }
  printf("\n");*/

  compress();

  getch();
  return(0);
}