#include <stdio.h>
#include <conio.h>

#include <crt.h>
#include <vga.h>
#include <vgapal.h>
#include <mouse.h>

#include <complex.h>

#include "bmp.cpp"
char fname[100];


#define DEEP   30
#define ZOOM   0.95

VirtualScreen *screen;
pal256 pal;
char coltab[256];
double xtab[VGA_WIDTH], ytab[VGA_HEIGHT];

void doMandel(double startX, double startY, double endX, double endY) {
  int i,j, rep;
  complex z, t;
  double sizX = fabs(startX-endX),
         sizY = fabs(startY-endY);

  for (j=0; j<VGA_HEIGHT; j++) {
    t = complex(0.0,ytab[j]*sizY+startY);
    for (i=0; i<VGA_WIDTH; i++) {
      t = complex(xtab[i]*sizX+startX, imag(t));
      z = complex(0,0);
      for (rep=0; rep<DEEP; rep++) {
        z = z*z+t;
        //if ((imag(z)>3.0)||(real(z)>3.0)) break;
        if (abs(z)>3.0) break;
      }
      if (rep<(DEEP-1)) screen->putPixel(i,j, coltab[rep]);
    }
  }
}

int main() {
  double sx,sy, ex,ey;
  double tx,ty, cx,cy;
  int a,b;

  mouse_reset();
  if (!mouseInfo.mousePresent) {
    puts("Please get a mouse!!");
    exit(1);
  }

  crt_init();
  crt_setVideoMode(0x13);
  screen = new VirtualScreen();
  screen->clear(0);
  mouse_show();

  pal_setGradient(&pal, 1,200, 0,20,30, 23,63,33);
  pal_setGradient(&pal, 201,255, 23,63,33, 63,63,63);
  pal_outAll(&pal);

  for (a=0; a<256; a++) coltab[a] = (a*255)/DEEP;
  for (a=0; a<VGA_WIDTH; a++) xtab[a] = (double)a/VGA_WIDTH;
  for (a=0; a<VGA_HEIGHT; a++) ytab[a] = (double)a/VGA_HEIGHT;
  sx = sy = -1.0;
  ex = ey = 1.0;
  long c = 0;
  do {
    doMandel(sx,sy, ex,ey);
    mouse_hide();
    screen->circle(160,100, 10, 255);
    screen->show();

/*    sprintf(fname, "mandelout/%i.bmp",c);
    bmpWrite(fname, screen, &pal, 0,0,319,199);
*/
    screen->clear(0);
    mouse_show();
    mouse_getStatus();

    a = mouseInfo.xPos-320;
    b = mouseInfo.yPos-100;
    if (abs(a) > 10) tx = ((double)a/400.0)*fabs(sx-ex); else tx = 0.0;
    if (abs(b) > 10) ty = ((double)b/400.0)*fabs(sy-ey); else ty = 0.0;

    sx += tx;
    sy += ty;
    ex += tx;
    ey += ty;

    cx = (ex+sx)/2.0;
    cy = (ey+sy)/2.0;

    sx = (sx-cx)*ZOOM+cx;
    sy = (sy-cy)*ZOOM+cy;
    ex = (ex-cx)*ZOOM+cx;
    ey = (ey-cy)*ZOOM+cy;

    c++;
  } while (!kbhit());
  getch();

  delete screen;
  crt_restoreVideoMode();
  return(0);
}