/*
SNAKES

compile with Turbo C++
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include <crt.h>

void play(unsigned freq, unsigned tim) {
  sound(freq);
  delay(tim);
  nosound();
}

typedef int ERRPROC(int, int);
typedef ERRPROC *PERRPROC;

#define MAXLEVELS   8
#define MAXPLAYERS  3
#define DELAY 130

int curDelay = DELAY;
int snakeDelay = curDelay;
int movesLeft = 0;
int multiplier = 1;
char enableSound = 1;

#include "snake.h"
#include "snakew.h"
#include "window.h"
#include "topscore.h"

char players = 1;
int curLevel = 1;
Snake *snakes[MAXPLAYERS] = {0,0,0};
SnakeWorld *world = 0;

int scoreLevel[MAXLEVELS+1] = {0, 200, 400, 600, 800, 1000, 1200, 1400, 2000};

void exitProc(int retCode) {
  int i;
  for (i=0; i<players; i++)
    if (snakes[i] != 0) {
      delete snakes[i];
      snakes[i] = 0;
    }
  if (world != 0) delete world;
  crt_restoreVideoMode();
  crt_enableBlink(1);
  _setcursortype(_NORMALCURSOR);
  puts("Grazie per aver giocato");
  exit(retCode);
}

void crt_printCenter(short y, BYTE attr, char *text) {
  short x = (crt_columns-strlen(text)) >> 1;
  crt_print(x, y, attr, text);
}

void initScreen() {
  char tc;

  crt_cls();
  crt_printCenter(3, 1, "ZioSoft entertainment presenta:");
  crt_printCenter(5, 4, "S  *  N  *  A  *  K  *  E  *  S");
  crt_printCenter(6, 4, "---------------------------------");
  crt_printCenter(23, 7, "premere ESC per uscire dal gioco");
  crt_print(20,10, 7, "Numero di giocatori (1,2,3): ");
  if (enableSound) {
    play(500, 110); delay(40);
    play(500, 60); delay(6);
    play(500, 60); delay(6);
    play(750, 300);
  }

  for (;;) {
    crt_setCursorPos(49,10);
    clreol();
    tc = getche();
    if (tc == 0x1B) exitProc(0);
    if ((tc >= '1')&&(tc <= '3')) {
      players = tc-'0';
      break;
    } else {
      crt_print(52,10,7,"Non valido!");
      delay(500);
    }
  }
  for (int i=0; i<players; i++) {
    char buff[36];
    snakes[i] = new Snake();
    crt_print(20,11+i, 7, "Nome giocatore  :");
    itoa(i+1, buff, 10);
    crt_printc(35,11+i, 7, buff[0]);
    crt_setCursorPos(38,11+i);
    //crt_gets(13, buff);
    fgets(buff,3, stdin);
    if (buff[0] == '\0') {
      sprintf(buff, "Giocatore %i", i+1);
      crt_print(38, 11+i, 7, buff);
    }
    snakes[i]->setName(buff);
  }
  crt_printCenter(19,3+16*8, "PREPARATI...");
  delay(1000);
}

void createLevelBorder() {
  world->addWallLine(0,0, world->getWidth()-1, 0);
  world->addWallLine(0,world->getHeight()-1, world->getWidth()-1, world->getHeight()-1);
  world->addWallLine(0,0, 0,world->getHeight()-1);
  world->addWallLine(world->getWidth()-1,0, world->getWidth()-1,world->getHeight()-1);
}

void createLevel(int level) {
  int i;
  int w = world->getWidth(),
      h = world->getHeight();
  createLevelBorder();
  switch (level) {
    case 1: break;
    case 2:
      world->addWallLine(2*w/5,10, 2*w/5, h-11);
      world->addWallLine(3*w/5,10, 3*w/5, h-11);
      break;
    case 3:
      world->addWallLine(w/2,10, w/2, h-11);
      world->addWallLine(10,h/2, w-11, h/2);
      break;
    case 4:
      world->addWallLine(w/4,0, w/4, h/2-5);
      world->addWallLine(w/4,h/2+5, w/4, h);
      world->addWallLine(3*w/4,0, 3*w/4, h/2-5);
      world->addWallLine(3*w/4,h/2+5, 3*w/4, h);
      world->addWallLine(w/4,h/2-5, w/2-5, h/2-5);
      world->addWallLine(w/4,h/2+5, w/2-5, h/2+5);
      world->addWallLine(w/2+5,h/2-5, 3*w/4, h/2-5);
      world->addWallLine(w/2+5,h/2+5, 3*w/4, h/2+5);
      break;
    case 5:
      world->addWallLine(w/8,h/8,7*w/8,h/8);
      world->addWallLine(w/8,h/8,w/8,7*h/8);
      world->addWallLine(w/8,7*h/8,7*w/8,7*h/8);
      world->addWallLine(7*w/8,7*h/8,7*w/8,3*h/8);
      world->addWallLine(7*w/8,3*h/8,3*w/8,3*h/8);
      world->addWallLine(3*w/8,3*h/8,3*w/8,5*h/8);
      world->addWallLine(3*w/8,5*h/8,5*w/8,5*h/8);
      break;
    case 6:
      for (i=0; i<3; i++) {
        int len = 10;
        world->addWallLine(11+len*i*2, h/6+1, 10+len*(i*2+1), h/6+len);
        world->addWallLine(11+len*i*2, 4*h/6+1, 10+len*(i*2+1), 4*h/6+len);
        world->addWallLine(21+len*i*2, h/6+len, 20+len*(i*2+1), h/6+1);
        world->addWallLine(21+len*i*2, 4*h/6+len, 20+len*(i*2+1), 4*h/6+1);
        world->addWallLine(21+len*i*2, h/6+len, 21+len*i*2,h/6+len*2);
        world->addWallLine(31+len*i*2, 4*h/6, 31+len*i*2,4*h/6-len);
      }
      break;
    case 7:
      world->addWallLine(w/8,h/6,7*w/8,h/6);
      world->addWallLine(w/8,h/6,w/8,5*h/6);
      world->addWallLine(7*w/8,h/6,7*w/8,5*h/6);
      world->addWallLine(2*w/8,5*h/6,6*w/8,5*h/6);
      world->addWallLine(2*w/8,5*h/6,2*w/8,2*h/6);
      world->addWallLine(6*w/8,5*h/6,6*w/8,2*h/6);
      world->addWallLine(3*w/8,2*h/6,5*w/8,2*h/6);
      world->addWallLine(3*w/8,2*h/6,3*w/8,4*h/6);
      world->addWallLine(5*w/8,2*h/6,5*w/8,4*h/6);
      world->addWallLine(w/2,3*h/6,w/2,5*h/6-2);
      world->addWallLine(2*w/8+2,5*h/6-2,6*w/8-2,5*h/6-2);
      break;
    case 8:
      world->addWallLine(10,8,w-8,8);
      world->addWallLine(8,10,8,h/2-1);
      world->addWallLine(10,h/2+1,w/2-1,h/2+1);
      world->addWallLine(w/2+1,10,w/2+1,h/2-1);
      world->addWallLine(w/2+1,h/2+1,w-10,h/2+1);
      world->addWallLine(w/2-1,h/2+3,w/2-1,h-10);
      world->addWallLine(10,h-8,w-10,h-8);
      world->addWallLine(w-8,h/2+3,w-8,h-10);
      world->addWallLine(w/6,h/3,5*w/6,h/3);
      world->addWallLine(w/6,2*h/3,5*w/6,2*h/3);
      break;
    default: break;
  }
}

void createSnakes(int level) {
  int i;
  int w = world->getWidth(),
      h = world->getHeight();
  const char colors[MAXPLAYERS] = {14,13,10};
  const char dirs[MAXLEVELS][MAXPLAYERS] =
    {{SNAKE_DIR_N,SNAKE_DIR_S,SNAKE_DIR_N},
     {SNAKE_DIR_N,SNAKE_DIR_S,SNAKE_DIR_N},
     {SNAKE_DIR_O,SNAKE_DIR_E,SNAKE_DIR_E},
     {SNAKE_DIR_O,SNAKE_DIR_N,SNAKE_DIR_E},
     {SNAKE_DIR_O,SNAKE_DIR_S,SNAKE_DIR_N},
     {SNAKE_DIR_O,SNAKE_DIR_S,SNAKE_DIR_N},
     {SNAKE_DIR_N,SNAKE_DIR_E,SNAKE_DIR_S},
     {SNAKE_DIR_N,SNAKE_DIR_N,SNAKE_DIR_E}};

  for (i=0; i<players; i++) {
    snakes[i]->clear();
    snakes[i]->setColor(colors[i]);
    snakes[i]->setDirection(dirs[level-1][i]);
  }
  switch (level) {
    case 1:
    case 2:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/3, h/2+i);
	if (players >= 2) {
	  snakes[1]->addPoint(w/2, h/2+(2-i));
	  if (players >= 3) {
	    snakes[2]->addPoint(2*w/3, h/2+i);
	  }
	}
      }
      break;
    case 3:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/4+i, h/3);
	if (players >= 2) {
          snakes[1]->addPoint(3*w/4+(2-i), h/3);
	  if (players >= 3) {
	    snakes[2]->addPoint(3*w/4+(2-i), 2*h/3);
	  }
	}
      }
      break;
    case 4:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/3+i, h/2);
	if (players >= 2) {
	  snakes[1]->addPoint(w/2, h/2+i);
	  if (players >= 3) {
	    snakes[2]->addPoint(2*w/3+(2-i), h/2);
	  }
	}
      }
      break;
    case 5:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/2+i, h/16);
	if (players >= 2) {
	  snakes[1]->addPoint(w/16, h/2+(2-i));
	  if (players >= 3) {
	    snakes[2]->addPoint(15*w/16, h/2+i);
	  }
	}
      }
      break;
    case 6:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/6+i, h/2);
	if (players >= 2) {
	  snakes[1]->addPoint(w/2-2, h/2+(2-i));
	  if (players >= 3) {
	    snakes[2]->addPoint(w-4, h/2+i);
	  }
	}
      }
      break;
    case 7:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(5*w/16, h/2+i);
	if (players >= 2) {
	  snakes[1]->addPoint(w/2+(2-i), h/12);
	  if (players >= 3) {
	    snakes[2]->addPoint(15*w/16, h/2+(2-i));
	  }
	}
      }
      break;
    case 8:
      for (i=0; i<3; i++) {
	snakes[0]->addPoint(w/16, h/2+i);
	if (players >= 2) {
	  snakes[1]->addPoint(15*w/16, h/2+i);
	  if (players >= 3) {
	    snakes[2]->addPoint(2*w/3+(2-i), 3*h/8);
	  }
	}
      }
      break;
  }
  if (level <= 1) for (i=0; i<players; i++) world->addSnake(snakes[i]);
}

void printScores() {
  char buff[100];
  char *lives = "\x03\x03\x03";
  int dist = (players==2)?40:27;
  crt_print(0,24, 0, buff);
  for (int i=0; i<players; i++) {
    sprintf(buff, "%s: %i (%i)    ", snakes[i]->getName(), snakes[i]->getScore(), snakes[i]->getScore()-scoreLevel[curLevel]);
    memcpy(buff+strlen(buff)-3, lives, snakes[i]->getLives());
    crt_print(dist*i,24, snakes[i]->getColor(), buff);
   }
}

void prepareGame(int level) {
  int i;
  char buff[100];

  crt_enableBlink(0);
  _setcursortype(_NOCURSOR);

  snakeDelay = curDelay;
  multiplier = 1;
  movesLeft = 0;

  if (level <= 1) world = new SnakeWorld(80, 48);
  world->clear();
  createLevel(level);
  createSnakes(level);
  printScores();

  srand(time(NULL));
  world->createDots();
  world->draw();

  Window *press = new Window(20,8, 60,13, 15+16*2);
  press->show();
  sprintf(buff, "Livello %i", level);
  crt_printCenter(10, press->getColor(), buff);
  crt_printCenter(11, press->getColor(), "Premere SPAZIO per iniziare...");
  while (getch() != ' ') ;
  delete press;
  if (enableSound) {
    play(300, 100); delay(10);
    play(400, 100); delay(10);
    play(500, 100);
  }
}

void pauseGame() {
  char key;
  Window *pause = new Window(20,6, 60,15, 15+16*2);
  pause->show();
  if (enableSound) {
    play(200, 50); delay(10);
    play(180, 50);
  }
  crt_printCenter(8, pause->getColor(), "P A U S A");
  crt_printCenter(11, pause->getColor(), "Premere ESC per uscire o");
  crt_printCenter(12, pause->getColor(), "SPAZIO per continuare.");

  do key = getch(); while ((key != 0x1B)&&(key != ' '));
  if (key == 0x1B) exitProc(0);
  delete pause;
}

void helpGame() {
  Window *help = new Window(15,3, 65,21, 15+16*2);
  help->show();
  if (enableSound) {
    play(100, 30); delay(8);
    play(400, 30); delay(8);
    play(800, 30);
  }
  crt_printCenter(4, help->getColor(), "G U I D A");
  crt_print(18, 6, help->getColor(), "Tasti:");
  crt_print(20, 7, help->getColor(), "Giocatore 1: Frecce");
  crt_print(20, 8, help->getColor(), "Giocatore 2: w a s d");
  crt_print(20, 9, help->getColor(), "Giocatore 3: i j k l");
  crt_print(18, 11, help->getColor(), "Punti:");
  crt_printc(20, 12, (WORLD_COLOR_DOT1 & 0x0F)|(help->getColor() & 0xF0), '');
  crt_print(22, 12, help->getColor(), ": 5 punti");
  crt_printc(20, 13, (WORLD_COLOR_DOT2 & 0x0F)|(help->getColor() & 0xF0), '');
  crt_print(22, 13, help->getColor(), ": 20 punti");
  crt_printc(20, 14, (WORLD_COLOR_DOT3 & 0x0F)|(help->getColor() & 0xF0), '');
  crt_print(22, 14, help->getColor(), ": 10 punti, velocit e punteggio doppi");
  crt_printc(20, 15, (WORLD_COLOR_DOT4 & 0x0F)|(help->getColor() & 0xF0), '');
  crt_print(22, 15, help->getColor(), ": 30 punti, massimo delle vite (3)");

  crt_printCenter(19, help->getColor(), "Premere SPAZIO per continuare...");
  while (getch() != ' ') ;
  delete help;
}

void lostGame(int snake) {
  int i;
  char buff[100];
  Window *pause = new Window(20,6, 60,15, 15+16*4);
  pause->show();
  crt_printCenter(8, pause->getColor(), "G A M E   O V E R");
  if (snake < 0x10) {
    sprintf(buff, "Peccato, %s, hai perso!", snakes[snake]->getName());
    crt_printCenter(10, pause->getColor(), buff);
  } else {
    sprintf(buff, "Peccato, %s e %s,", snakes[snake & 0x0F]->getName(), snakes[(snake >> 4)-1]->getName());
    crt_printCenter(10, pause->getColor(), buff);
    crt_printCenter(11, pause->getColor(), "avete perso!");
  }
  crt_printCenter(13, pause->getColor(), "Premere SPAZIO per continuare...");
  while (getch() != ' ') ;
  delete pause;

  Window *topten = new Window(20,3, 60,22, 15+16*2);
  topten->show();
  crt_printCenter(5, topten->getColor(), "C L A S S I F I C A");
  crt_printCenter(20, topten->getColor(), "Premere SPAZIO per uscire...");

  TopScore *top = new TopScore();
  top->readScores();
  for (i=0; i<players; i++) top->addScore(snakes[i]->getName(), snakes[i]->getScore());
  top->writeScores();
  for (i=0; i<top->getScores(); i++) {
    int sc;
    top->getScore(i, buff, &sc);
    crt_print(24, 8+i, topten->getColor(), buff);
    sprintf(buff, "%6i", sc);
    crt_print(48, 8+i, topten->getColor(), buff);
  }
  delete top;

  while (getch() != ' ') ;
  delete topten;
  exitProc(0);
}

void lostLife(int snake) {
  char buff[100];
  Window *pause = new Window(16,6, 64,15, 15+16*4);
  pause->show();
  crt_printCenter(8, pause->getColor(), "C O L P I T O");
  if (snake < 0x10) {
    sprintf(buff, "Attento, %s, hai perso una vita!", snakes[snake]->getName());
    crt_printCenter(10, pause->getColor(), buff);
  } else {
    sprintf(buff, "Attenti, %s e %s,", snakes[snake & 0x0F]->getName(), snakes[(snake >> 4)-1]->getName());
    crt_printCenter(10, pause->getColor(), buff);
    crt_printCenter(11, pause->getColor(), "avete perso una vita!");
  }
  crt_printCenter(13, pause->getColor(), "Premere SPAZIO per continuare...");
  while (getch() != ' ') ;

  delete pause;
}

int startGame() { // return: 0=exit, 1=gotonextlevel
  int i,j;
  char bonk = -1;
  char playing = 1;

  do {
    world->animate();
    crt_activePage = 1;
    world->draw();
    printScores();
    crt_copyPage(0,1);
    crt_getPage();
    bonk = world->getCollision();
    if (bonk != -1) { //collision
      if (enableSound) {
	play(200, 80); delay(10);
	play(100, 100); delay(12);
	play(50, 200);
      }
      i = snakes[bonk & 0x0F]->getLives();
      j = (bonk >= 0x10)?(snakes[(bonk >> 4)-1]->getLives()):-1;
      if ((i > 1)||(j != -1)) {
        snakes[bonk & 0x0F]->setLives(i-1);
        if (j != -1) snakes[(bonk >> 4)-1]->setLives(j-1);
        lostLife(bonk);
        curLevel--;
        return(1);
      } else {
        lostGame(bonk);
        playing = 0;
      }
    }
    if (curLevel < MAXLEVELS) {
      for (i=0; i<players; i++)
	if (snakes[i]->getScore() >= scoreLevel[curLevel]) return(1);
    }
    delay(snakeDelay);
    if (movesLeft > 0) {
      if (movesLeft < 10) play(100, 5);
      movesLeft--;
    } else {
      snakeDelay = curDelay;
      multiplier = 1;
    }
    if (kbhit()) {
      char key = getch();
      switch (key) {
	case 0x1B:
	case 'p':
	case 'P':
	  pauseGame();
	  break;
	case 0:
	  key = getch();
	  switch (key) {
	    case 59: // F1 = help
	      helpGame(); break;
	    case 75: //sx
	      snakes[0]->changeDirection(SNAKE_DIR_O); break;
	    case 77: //dx
	      snakes[0]->changeDirection(SNAKE_DIR_E); break;
	    case 72: //up
	      snakes[0]->changeDirection(SNAKE_DIR_N); break;
	    case 80: //down
	      snakes[0]->changeDirection(SNAKE_DIR_S); break;
	  }
	  break;
	case 'a': //sx
	case 'A':
	  if (players >= 2) snakes[1]->changeDirection(SNAKE_DIR_O); break;
	case 'd': //dx
	case 'D':
	  if (players >= 2) snakes[1]->changeDirection(SNAKE_DIR_E); break;
	case 'w': //up
	case 'W':
	  if (players >= 2) snakes[1]->changeDirection(SNAKE_DIR_N); break;
	case 's': //down
	case 'S':
	  if (players >= 2) snakes[1]->setDirection(SNAKE_DIR_S); break;
	case 'j': //sx
	case 'J':
	  if (players >= 3) snakes[2]->changeDirection(SNAKE_DIR_O); break;
	case 'l': //dx
	case 'L':
	  if (players >= 3) snakes[2]->changeDirection(SNAKE_DIR_E); break;
	case 'i': //up
	case 'I':
	  if (players >= 3) snakes[2]->changeDirection(SNAKE_DIR_N); break;
	case 'k': //down
	case 'K':
	  if (players >= 3) snakes[2]->setDirection(SNAKE_DIR_S); break;
      }
    }
  } while (playing);
  return(0);
}

void printCmdHelp() {
  puts("Opzioni di SNAKES:");
  puts(" /S  :  disabilita il suono");
  puts(" /Vx :  imposta la velocit ad x (da 0 a 300)");
  puts(" /?  :  visualizza queste opzioni");
}

void readCmdLine(int argc, char *argv[]) {
  int i, ret;
  for (i=1; i<argc; i++) {
    if (*(argv[i]) == '/') {
      switch (*(argv[i]+1)) {
	case '?':
	  printCmdHelp();
	  exit(0);
	  break;
        case 's':
        case 'S':
          enableSound = 0;
	  break;
        case 'v':
        case 'V': {
          int v = atoi(argv[i]+2);
          v = max(0, min(v, 300));
          curDelay = 300-v;
          break;
        }
      }
    }
  }
}

void main(int argc, char *argv[]) {
  int ret;

  readCmdLine(argc, argv);
  crt_setVideoMode(3);
  crt_init();

  initScreen();
  do {
    prepareGame(curLevel);
    ret = startGame();
    curLevel++;
    if (curLevel > MAXLEVELS) curLevel = MAXLEVELS;
  } while (ret == 1);


  exitProc(0);
}