/*
topscore class
*/

#define SCOREFILE  "snakes.top"
#define MAXSCORES  10

typedef struct {
  int score;
  char name[13];
} SCORE, *PSCORE;

class TopScore {
 public:
  void readScores();
  void writeScores();
  int getScores() { return(MAXSCORES); }
  void getScore(int, char*, int*);
  char addScore(char *, int);
  void sort();
 private:
  SCORE scores[MAXSCORES];
  int findMin();
};

void TopScore::readScores() {
  int i;
  FILE *f = fopen(SCOREFILE, "r");

  for (i=0; i<MAXSCORES; i++) {
    scores[i].score = 0;
    strcpy(scores[i].name, "nobody");
  }
  if (f == 0) { // file does not exist

  } else {
    i = 0;
    while (!feof(f)) {
      fscanf(f, "%s %i\n", &(scores[i].name), &(scores[i].score));
      i++;
    }
    fclose(f);
  }
}

void TopScore::sort() {
  int i,j;
  for (i=0; i<MAXSCORES-1; i++) {          // sort scores
    for (j=i+1; j<MAXSCORES; j++) {
      if (scores[i].score < scores[j].score) {
	SCORE t = scores[i];
	scores[i] = scores[j];
	scores[j] = t;
      }
    }
  }
}

void TopScore::writeScores() {
  FILE *f = fopen(SCOREFILE, "w");  // overwrite score file if exist

  sort();
  if (f == 0) return; // no write if error
  for (int i=0; i<MAXSCORES; i++) {
    fprintf(f, "%s %i\n", scores[i].name, scores[i].score);
  }
  fclose(f);
}

int TopScore::findMin() {
  int m = 0;
  for (int i=1; i<MAXSCORES; i++) if (scores[i].score < scores[m].score) m = i;
  return(m);
}

void TopScore::getScore(int index, char *nam, int *score) {
  strcpy(nam, scores[index].name);
  *score = scores[index].score;
}

char TopScore::addScore(char *name, int score) {
  int min = findMin();
  if (scores[min].score >= score) return(0); // not added
  strcpy(scores[min].name, name);
  scores[min].score = score;
  return(1);
}