#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <alloc.h>
#include <mem.h>

#define lenArray  10000

template <class var>
void xchg(var &a, var &b) {
  var t = a; a = b; b = t;
}
template <class var>
void cmpxchg(var &a, var &b) {
  if (b<a) xchg(a,b);
}

void select(int low, int high, int list[]) {
  int i,j;
  printf("Selezione: ");
  for (j = low; j < high; j++) {
    int min = j;
    for (i = j+1; i <= high; i++)
      if (list[i] < list[min]) min = i;
    xchg(list[j],list[min]);
  }
}

void insert(int low, int high, int list[]) {
  int i,j;
  printf("Inserzione: ");
  for (i = high; i > low; i--) cmpxchg(list[i-1],list[i]);
  for (j = low+2; j <= high; j++) {
    i = j;
    int v = list[j];
    while (v < list[i-1]) {
      list[i] = list[i-1];
      i--;
    }
    list[i] = v;
  }
}

void bubble(int low, int high, int list[]) {
  int i,j;
  printf("Bubble sort: ");
  for (j = low; j < high; j++)
    for (i = high; i > j; i--)
      cmpxchg(list[i-1],list[i]);
}

void shell(int low, int high, int list[]) {
  int i,j, h;
  printf("Shellsort: ");
  for (h = 1; h <= (high-low)/9; h = 3*h+1);
  for ( ; h > 0; h /= 3)
    for (i = low+h; i <= high; i++) {
      j = i;
      int v = list[i];
      while (j >= low+h && v < list[j-h]) {
	list[j] = list[j-h];
	j -= h;
      }
      list[j] = v;
    }
}

void check(int low, int high, int list[]) {
  for (int i = low; i < high; i++)
    if (list[i] > list[i+1]) {
      printf("Non ordinato! ");
      return;
    }
}

void sort(int low, int high, int list[], void alg(int low, int high, int list[])) {
  char s = 0, hs = 0;
  struct dostime_t t1,t2;
  _dos_gettime(&t1);
  alg(low, high, list);
  _dos_gettime(&t2);
  check(low, high, list);
  if (t1.second == t2.second) { hs = t2.hsecond-t1.hsecond; } else
    if (t1.hsecond < t2.hsecond) {
      s = t2.second-t1.second;
      hs = t2.hsecond-t1.hsecond;
    } else {
      s = t2.second-t1.second-1;
      hs = 100-(t1.hsecond-t2.hsecond);
    }
  printf("%hi.%hi sec.\n",s,hs);
}

void main() {
  int i;
  int array[lenArray];

  clrscr();
  printf("Algoritmi di ordinamento\n");

  printf("Generazione %i numeri casuali... ",lenArray);
  randomize();
  for (i=0;i<lenArray;i++) array[i] = random(1000)-500;
  printf("ok\n");

  printf("\n1) Selezione\n"
	 "2) Inserzione\n"
	 "3) Bubble sort\n"
	 "4) Shellsort\n"
	 "5) Quicksort --incompleto\n"
	 "0) tutti\n");
  printf("Scegli un tipo di ordinamento: ");
  char ord = getche();
  printf("\n");

  switch (ord) {
    case '0': {
      void (*funcs[])(int,int,int[]) = {select, insert, bubble, shell};
      int far *backup = (int far *)farmalloc(sizeof(array));
      if (!backup) return;
      _fmemcpy(backup, array, sizeof(array));
      for (i=0;i<4;i++) {
	sort(0,lenArray-1, array, funcs[i]);
	_fmemcpy(array, backup, sizeof(array));
      }
      farfree(backup);
      break;
    }
    case '1': sort(0,lenArray-1, array, select); break;
    case '2': sort(0,lenArray-1, array, insert); break;
    case '3': sort(0,lenArray-1, array, bubble); break;
    case '4': sort(0,lenArray-1, array, shell); break;
  }

  //for (i=0;i<lenArray;i++) printf("%i ",array[i]);

  getch();
}