#pragma option -f

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <dir.h>
#include <time.h>

#include <crt.h>
#include <vga.h>
#include <vgapal.h>

#include <mouse.h>
#include "space.h"

const char *initpath = "C:\\*.*";

typedef struct {
  point pos;
  char name[20];
  int color;
} globe, *pglobe;

int iGlobes = 0;
globe *globes = NULL;

void initglobes() {
  int res;
  ffblk find;

  srand(time(NULL));
  res = findfirst(initpath, &find, FA_ARCH);
  while (res == 0) {
    globes = (globe*)realloc(globes, sizeof(globe)*(iGlobes+1));
    if (globes == NULL) exit(-1);
    strncpy((globes+iGlobes)->name, find.ff_name, 13);
    (globes+iGlobes)->color = iGlobes+1;

    (globes+iGlobes)->pos.x = ((((long)rand())*rand())%1000)-500;
    (globes+iGlobes)->pos.y = ((((long)rand())*rand())%1000)-500;
    (globes+iGlobes)->pos.z = ((((long)rand())*rand())%1000)-500;

    iGlobes++;
    res = findnext(&find);
  }

  /*for (int i=0; i<GLOBES; i++) {
    pts[i].x = ((((long)rand())*rand())%1000)-500;
    pts[i].y = ((((long)rand())*rand())%1000)-500;
    pts[i].z = ((((long)rand())*rand())%1000)-500;
  }*/
}


int main() {
  int i,j;
  int px,py, rx,ry;

  crt_init();
  crt_cls();

  mouse_reset();
  if (!mouseInfo.mousePresent) {
    printf("Install a mouse first!\n");
    exit(1);
  }

  crt_setVideoMode(0x13);

  pal256 pal1;
  pal1[0].r = pal1[0].g = pal1[0].b = 0;
  pal_setGradient(&pal1, 1,255, 10,10,30, 30,30,63);
  //pal_outAll(&pal1);

  VirtualScreen *vir1 = new VirtualScreen();
  vir1->clear(0);
  mouse_show();

  Projector *pro = new Projector();

  initglobes();

  pro->setOrigin(0,0,-100);
  pro->setMe(0,0,0);
  pro->moveMe(0,0,-2000);
  pro->setUnits(80,80);
  double speed = 5;

  while (!kbhit()) {
    point m = *pro->getMe();
    for (j=0; j<iGlobes; j++) {
      int r = pro->trace(&((globes+j)->pos), &px, &py);
      if (r != 0) continue;
      double d = pro->calcDistOrigin(&((globes+j)->pos));
      d = sqrt(d);
      //vir1->fCircle(px, py, 20-(min(d,500)/25), 300-(255*min(d,500)/500) );
      vir1->fCircle(px, py, 20-(min(d,30)/1.5), (globes+j)->color);

    }

    mouse_getStatus();
    double rotx, roty;
    rotx = (320-mouseInfo.xPos)/1000000.0;
    roty = (100-mouseInfo.yPos)/1000000.0;
    if (mouseInfo.leftButton) speed += 1;
    if (mouseInfo.rightButton) speed -= 1;

    point c = *pro->getOrigin();
    //point c = {0,0,0};
    pro->moveMeRel(0,0,speed);
    if (rotx != 0 || roty != 0) {
      pro->rotateMeRel(&c, roty, rotx, 0.0);
    }
    //pro->moveOriginCloser(0.5);

    delay(20);

    mouse_hide();
    //mouse_show();
    vir1->show();
    mouse_show();

    vir1->clear(0);
  }
  getch();

  crt_restoreVideoMode();
  delete pro;
  delete vir1;
  free(globes);
  return(0);
}