#include <stdlib.h>
#include <dos.h>
#include <time.h>
#include <math.h>
#include <crt.h>
#include <vga.h>
#include <vgapal.h>

#include "bmp.cpp"
char fname[100];
int c = 0;

#define DELAY        10
#define SPEED_STARS   2
#define SPEED_TEXT    1
#define MAXSTARS    400
#define SIZEZ       500

#define SHAPE_XT     160   //        _         (xtop,ytop)
#define SHAPE_YT       0   //       / \
#define SHAPE_YM      50   //      /___\       (ym)
#define SHAPE_YB     199   //     /     \
#define SHAPE_XB1      0   //    /       \
#define SHAPE_XB2    319   //   /_________\    (yb)
                           // (xb1)     (xb2)

#define STW_LINES   9

int textLen[STW_LINES];
int maxTextLen = 0;
const char *stw_text[STW_LINES] =
  {"Star Wars",
   "",
   "Episodio XII",
   "",
   "Tanto tempo fa",
   "in una galassia",
   "lontana lontana",
   "l'imperatore aveva",
   "il dominio..."};

typedef struct { // linked with to2D()
  int x,y,z;
} POINT, *PPOINT;

VirtualScreen *mainScr = 0;
pal256 mainPal, stdPal;
POINT stars[MAXSTARS];
BYTE far *starScr;


void to2D(POINT p, int *x, int *y) {
  //*x = (long)p.x*(p.z+SIZEZ/2)/SIZEZ;
  //*y = (long)p.y*(p.z+SIZEZ/2)/SIZEZ;
  asm {
    //push  si
    lea   si, p
    mov   cx, SIZEZ
    mov   ax, [si+4] // load z
    add   ax, SIZEZ/2
    push  ax
    imul  word [si+0] // mul x
    idiv  cx
    mov   bx, x
    mov   [bx], ax
    pop   ax
    imul  word [si+2] // mul y
    idiv  cx
    mov   bx, y
    mov   [bx], ax
    //pop   si
  }
}

void createStar(int i) {
  int siz;
  stars[i].z = -rand()%(SIZEZ/2);
  siz = 1000-stars[i].z*2;
  stars[i].x = rand()%siz-siz/2;
  stars[i].y = rand()%siz-siz/2;
}

void initStwars() {
  int i;

  srand(time(0));
  crt_init();
  crt_setVideoMode(0x13);
  mainScr = new VirtualScreen();
  mainScr->clear(0);

  pal_inAll(&stdPal);
  pal_setGradient(&mainPal, 0x10,0x2F, 0,0,0, 63,63,63);  // white
  pal_setGradient(&mainPal, 0x30,0x40, 2,2,0, 30,30,10);  // textcolor
  pal_setGradient(&mainPal, 0x40,0x8F, 30,30,10, 63,63,10);
  pal_outAll(&mainPal);

  for (i=0; i<MAXSTARS; i++) createStar(i);
  for (i=0; i<STW_LINES; i++) {
    textLen[i] = strlen(stw_text[i]);
    if (textLen[i] > maxTextLen) maxTextLen = textLen[i];
  }
  starScr = (BYTE far *)farmalloc((long)maxTextLen*8*17);
}

void doneStwars() {
  if (starScr != 0) farfree(starScr);
  delete mainScr;
  pal_outAll(&stdPal);
  crt_restoreVideoMode();
}

void doStars() {
  int i, x,y;
  BYTE color;
  for (i=0; i<MAXSTARS; i++) {
    stars[i].z += SPEED_STARS+min((stars[i].z+SIZEZ/2),SIZEZ)*4/SIZEZ;
    color = min(stars[i].z+SIZEZ/2,SIZEZ-1)*32/SIZEZ+0x10;
    to2D(stars[i], &x, &y);
    x += 160;  y = 100-y;
    if ((x < 0)||(y < 0)||(x > VGA_MAXX)||(y > VGA_MAXY)) createStar(i);
    else mainScr->putPixel(x,y, color);
  }
}

int calcHeight(int y) { // SHAPE_YM <= y <= SHAPE_YB
  static BYTE *hTab = 0;
  if (hTab == 0) { // precalc
    hTab = (BYTE*)malloc((SHAPE_YB-SHAPE_YM+1));
    if (hTab == 0) return(15*y/(SHAPE_YB>>2-SHAPE_YT));
    for (int i=SHAPE_YM; i<=SHAPE_YB; i++) {
      hTab[i-SHAPE_YM] = 15*i/(SHAPE_YB>>2-SHAPE_YT);
    }
  }
  return(hTab[y-SHAPE_YM]);
}

void calcS(int y, int j, int *s1, int *s2) { // SHAPE_YT <= y <= SHAPE_YB
  static int maxh = calcHeight(SHAPE_YB);
  static int *sTab = 0;
  int x1,x2,x3,x4;

  if (sTab == 0) {
    sTab = (int*)malloc((unsigned)(SHAPE_YB-SHAPE_YT+17)*2*maxh*sizeof(int));
    if (sTab == 0) return;
    for (int k=SHAPE_YT; k<=SHAPE_YB+16; k++) {
      x1 = SHAPE_XT-(long)(k-SHAPE_YT)*(SHAPE_XT-SHAPE_XB1)/(SHAPE_YB-SHAPE_YT);
      x2 = SHAPE_XT+(long)(k-SHAPE_YT)*(SHAPE_XB2-SHAPE_XT)/(SHAPE_YB-SHAPE_YT);
      x3 = SHAPE_XT-(long)(16+k-SHAPE_YT)*(SHAPE_XT-SHAPE_XB1)/(SHAPE_YB-SHAPE_YT);
      x4 = SHAPE_XT+(long)(16+k-SHAPE_YT)*(SHAPE_XB2-SHAPE_XT)/(SHAPE_YB-SHAPE_YT);
      for (int i=0; i<maxh; i++) {
        *(sTab+(k-SHAPE_YT)*maxh*2+i*2+0) = max(x1-(x1-x3+1)*(i+1)/16, 0);
        *(sTab+(k-SHAPE_YT)*maxh*2+i*2+1) = min(x2+(x4-x2+1)*(i+1)/16, VGA_MAXX);
      }
    }
  }
  *s1 = *(sTab+((y-SHAPE_YT)*maxh+j)*2+0);
  *s2 = *(sTab+((y-SHAPE_YT)*maxh+j)*2+1);
}

BYTE calcCol(int y) { // SHAPE_YM <= y <= SHAPE_YB
  static BYTE *colTab = 0;
  if (colTab == 0) {
    colTab = (BYTE*)malloc((SHAPE_YB-SHAPE_YM+1)*sizeof(BYTE));
    if (colTab == 0) return( (y-SHAPE_YM)*96/(SHAPE_YB-SHAPE_YM+1)+0x30 );
    for (int j=SHAPE_YM; j<=SHAPE_YB; j++)
      colTab[j-SHAPE_YM] = (j-SHAPE_YM)*96/(SHAPE_YB-SHAPE_YM+1)+0x30;
  }
  return(colTab[y-SHAPE_YM]);
}

void fastText(int id, BYTE color) {
  int i,j,k;
  BYTE chr;
  static BYTE far *charTab = 0;
  if (charTab == 0) {
    asm {
      push  es
      push  bp
      mov   ax, 0x1130
      mov   bh, 0x06
      int   0x10
      mov   word [charTab], bp   // only if static
      mov   word [charTab+2], es
      pop   bp
      pop   es
    }
  }
  for (i=0; i<textLen[id]; i++) {
    for (j=0; j<16; j++) {
      chr = *(charTab+(BYTE)stw_text[id][i]*16+j);
      for (k=0; k<8; k++) {
	asm rol chr, 1;
	if (chr & 0x01) *(starScr+(j*maxTextLen+i)*8+k) = color;
      }
    }
  }
}

void starLine(int y, int idtext) {
  int i,j,k, s1,s2, px,py, height;
  BYTE col,col2;

  if ((y > SHAPE_YB)||(y < SHAPE_YM)) return;
  height = calcHeight(y);

  int len = textLen[idtext];
  _fmemset(starScr, 0, maxTextLen*8*17);
  fastText(idtext, 1);

  for (j=0; j<height; j++) {
    if (y+j > SHAPE_YB) break;
    if (y+j < SHAPE_YM) continue;
    calcS(y,j, &s1, &s2);
    k = s2-s1+1;
    col = calcCol(y+j);
    py = ((j+1)<<4)/height;
    for (i=s1; i<=s2; i++) {
      //px = (long)(i-s1)*len*8/(s2-s1+1);
      asm {
        mov   ax, i
        sub   ax, s1
        shl   ax, 3
        imul  len
        idiv  k
        mov   px, ax
      }
      if (*(starScr+py*maxTextLen*8+px)) mainScr->putPixel(i,y+j,col);
    }
  }
}

void doText() {
  static int i = SHAPE_YB;
  int j,np;
  for (j=0,np=i; j<STW_LINES; j++) {
    starLine(np, j);
    np += 50;
    if (np > SHAPE_YB) break;
  }
  if (np-30 < SHAPE_YM) i = SHAPE_YB; else i -= SPEED_TEXT;
}

void main() {

  initStwars();

  do {
    doStars();
    doText();
    mainScr->show();

/*    sprintf(fname, "stwarout/%i.bmp",c++);
    bmpWrite(fname, mainScr, &mainPal, 0,0,319,199);
*/
    mainScr->clear(0);
    delay(DELAY);
  } while (!kbhit()); getch();

  doneStwars();
}