#pragma option -1

#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <crt.h>
#include <mouse.h>


const char *mtype[] = {"--","bus","serial","inPort","PS/2","HP"};
const char *inttype[] = {"PS/2","--","IRQ2","IRQ3","IRQ4","IRQ5","IRQ6","IRQ7","IRQ8","IRQ9","IRQ10","IRQ11","IRQ13","IRQ14","IRQ15"};

#pragma option -k-
void segDS() {     // NOT A FUNCTION! DON'T CALL IT!!
  asm DW 0x9090;
};
#pragma option -k

void far trapMouse() {
  asm {
    push  ds
    push  es
    pusha
    mov   ax, cs:[segDS]
    mov   ds, ax
    mov   es, ax
  }
  int xpos = _CX;
  int ypos = _DX;
  int btn = _BX;
  char buff[50];

  sprintf(buff, "Position: %i %i   ",xpos,ypos);
  crt_print(0,8, 7,buff);
  crt_print(0,9, 7,(btn & 0x01)?"Left button":"             ");
  crt_print(0,10, 7,(btn & 0x02)?"Right button":"             ");

  asm {
    popa
    pop   es
    pop   ds
  }
}

void main() {
  clrscr();

  asm {
    mov   ax, ds
    mov   cs:[segDS], ax
  }

  crt_init();
  if (!mouse_reset()) {
    puts("Mouse not found!");
    exit(1);
  }
  mouse_getType();

  printf("Mouse found!\n\n");
  printf("Driver version: %i.%i\n",mouseInfo.driverVerMajor,mouseInfo.driverVerMinor);
  printf("Type: %s on %s\n", mtype[mouseInfo.mouseType],inttype[mouseInfo.mouseInt]);
  printf("Buttons: %i\n", mouseInfo.buttons);
  printf("Copyright: %Fs\n",mouse_getCopyrightText());

  int mask = MOUSE_MASK_MOVE | MOUSE_MASK_PRESSL | MOUSE_MASK_PRESSR;

  mouse_setHandler(mask, trapMouse);

  mouse_show();

  do {
    //printf("Position: %i %i   \n", mouseInfo.xPos, mouseInfo.yPos);
    //printf("Button1: %i\nButton2: %i\nButton3: %i", mouseInfo.leftButton,mouseInfo.rightButton,mouseInfo.middleButton);
    //mouse_hide();
    //if (mouseInfo.leftButton) crt_printc(mouseInfo.xPos>>3, mouseInfo.yPos>>3, 3, '');
    //if (mouseInfo.rightButton) crt_printc(mouseInfo.xPos>>3, mouseInfo.yPos>>3, 7, ' ');
    //mouse_show();
  } while (!kbhit()); getch();


}