#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt.h>
#include <vga.h>

void putpixel(unsigned int x, unsigned int y, unsigned char color) {
  const vga_width = 320;
  if ((x >= 320)||(y >= 200)) return;
  *(videoseg+y*vga_width+x) = color;
}

void line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned char color) {
  int dx = x2-x1, dy = y2-y1,
      ix = abs(dx), iy = abs(dy),
      inct = (ix>iy?ix:iy),
      plotX = x1, plotY = y1,
      x = 0, y = 0,
      i;
  unsigned char plot;
  putpixel(plotX,plotY, color);
  for (i=0;i<=inct;i++) {
    x += ix;
    y += iy;
    plot = 0;
    if (x > inct) {
      plot = 1;
      x -= inct;
      if (dx > 0) plotX++;
      if (dx < 0) plotX--;
     }
     if (y > inct) {
       plot = 1;
       y -= inct;
       if (dy > 0) plotY++;
       if (dy < 0) plotY--;
     }
     if (plot) putpixel(plotX,plotY, color);
  }
}

#include <w3d.h>

void fTri(VirtualScreen *virscr, int x1, int y1, int x2, int y2, int x3, int y3, char color) {
  /*double a,b;

  long px,py;
  int startx = min(x1,min(x2,x3))-x3,
      starty = min(y1,min(y2,y3))-y3,
      endx = max(x1,max(x2,x3))-x3,
      endy = max(y1,max(y2,y3))-y3;
  long p1x = x1-x3,
      p1y = y1-y3,
      p2x = x2-x3,
      p2y = y2-y3,
      pyy;
  char yetzero = 0;
  if (p1y != 0) {
    p1y = 0;
    p2y = p1y*p2x-p1x*p2y;
  } else yetzero = 1;
  //if (p2y == 0) return;

  for (py=starty; py<=endy; py++) {
    for (px=startx; px<=endx; px++) {
      pyy = (yetzero)?py:(p1y*px-p1x*py);

      //if (p2y == 0) continue;
      b = (1.0*pyy)/p2y;
      a = (((1.0*px)-p2x*b))/p1x;
      if (a+b > 1.000000) continue;
      if ((a >= 0) && (b >= 0)) virscr->putPixel(px+x3,py+y3, color);
    }
  }
  */
  int a,b, limit;
  int posx,posy;
  limit = max(abs(x1-x2),max(abs(x2-x3),abs(x3-x1)));
  limit = max(limit, max(abs(y1-y2),max(abs(y2-y3),abs(y3-y1))));
  long p1x = x1-x3,
      p1y = y1-y3,
      p2x = x2-x3,
      p2y = y2-y3,
      p3x = limit*x3,
      p3y = limit*y3;
  for (a=0; a<limit; a++) {
    for (b=0; b<limit; b++) {
      if (a+b >= limit) break;
      //posx = (a*p1x+b*p2x+p3x)/limit;
      asm {
        mov  ax, a
        imul word ptr p1x
        push dx
        push ax
        mov  ax, b
        imul word ptr p2x
        pop  bx
        add  ax, bx
        pop  bx
        adc  dx, bx
        add  ax, word ptr p3x
        adc  dx, word ptr p3x+2
        idiv limit
        mov  posx, ax
     }
     //posy = (a*p1y+b*p2y+p3y)/limit;
     asm {
        mov  ax, a
        imul word ptr p1y
        push dx
        push ax
        mov  ax, b
        imul word ptr p2y
        pop  bx
        add  ax, bx
        pop  bx
        adc  dx, bx
        add  ax, word ptr p3y
        adc  dx, word ptr p3y+2
        idiv limit
        mov  posy, ax
      }
      virscr->putPixel(posx, posy, color);
    }
  }
}

void main() {
  int i;
  crt_init();
  crt_cls();

  VirtualScreen *vir1 = new VirtualScreen();
  point *ph = new point;              // gestori di strutture
  object3D *obj = new object3D(ph);   //
  world3D *w3d = new world3D(obj,"MyWorld");
  ph->parentObj = (obj_p *)obj;
  obj->parentWld = (wld_p *)w3d;

  crt_setVideoMode(0x13);
  randomize();

  point3Ds triP[4] = {{10,10,0}, {40,50,0}, {70,10,0}, {40,20,40}};
  edge triE[6] = {{0,1},{1,2},{2,0},{0,3},{1,3},{2,3}};

  object3Ds tri;

  obj->init(&tri);
  obj->setName(&tri, "obj_ftri");
  for (i=0;i<5;i++) obj->addNode(&tri,triP[i]);
  for (i=0;i<7;i++) obj->addEdge(&tri,triE[i]);
  obj->scaleO(&tri, 2,2,2);

  w3d->addObj(tri);
  w3d->perspective = 1;

  vir1->clear(0);

  point2Ds p2,p3,p4;

  i = 0;
  while (!kbhit()) {
  i++;
  //if (i > 5) break;
    //vir1->fTri(random(320),random(200), random(320),random(200), random(320),random(200), random(16));
    fTri(vir1, random(320),random(200), random(320),random(200), random(320),random(200), random(16));
    //fTri(vir1, 0,0,320,10, 320,200, 5);
    /*ph->to2D(obj->getNode(&tri,0),&p2);
    ph->to2D(obj->getNode(&tri,1),&p3);
    ph->to2D(obj->getNode(&tri,2),&p4);
    vir1->fTri(p2.x+160,100-p2.y, p3.x+160,100-p3.y, p4.x+160,100-p4.y, 5);

    ph->to2D(obj->getNode(&tri,1),&p2);
    ph->to2D(obj->getNode(&tri,2),&p3);
    ph->to2D(obj->getNode(&tri,3),&p4);
    vir1->fTri(p2.x+160,100-p2.y, p3.x+160,100-p3.y, p4.x+160,100-p4.y, 6);

    ph->to2D(obj->getNode(&tri,2),&p2);
    ph->to2D(obj->getNode(&tri,3),&p3);
    ph->to2D(obj->getNode(&tri,4),&p4);
    vir1->fTri(p2.x+160,100-p2.y, p3.x+160,100-p3.y, p4.x+160,100-p4.y, 4);

    obj->rotateO(&tri,0.02,0.01,0.01);
    */
    //w3d->draw();

    vir1->show();

    //vir1->clear(0);
    //delay(10);
  }

  getch();

  crt_restoreVideoMode();

  delete w3d;
  delete obj;
  delete ph;
  delete vir1;
}
