// VESA test program
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>

#include <dos.h>
#include <dtypes.h>
#include <crt.h>
#include <vgapal.h>
#include <vga.h>
#include <vesa.h>

//-----------------------------------------------------------------------
// overloaded operators for RGBcol

RGBcol operator +(RGBcol c1, RGBcol c2) {
  RGBcol res;
  res.b = min(c1.b+c2.b,31);       // with saturation
  res.g = min(c1.g+c2.g,63);
  res.r = min(c1.r+c2.r,31);
  /*res.b = c1.b+c2.b;
  res.g = c1.g+c2.g;
  res.r = c1.r+c2.r;*/
  return res;
}

RGBcol operator *(RGBcol c1, RGBcol c2) {
  RGBcol res;
  res.b = c1.b*c2.b;
  res.g = c1.g*c2.g;
  res.r = c1.r*c2.r;
  return res;
}

RGBcol operator -(RGBcol c1, RGBcol c2) {
  RGBcol res;
  res.b = c1.b-c2.b;
  res.g = c1.g-c2.g;
  res.r = c1.r-c2.r;
  return res;
}

RGBcol operator /(RGBcol c1, int num) {
  RGBcol res;
  res.b = c1.b/num;
  res.g = c1.g/num;
  res.r = c1.r/num;
  return res;
}

RGBcol operator >>(RGBcol c1, int num) {
  RGBcol res;
  res.b = c1.b>>num;
  res.g = c1.g>>num;
  res.r = c1.r>>num;
  return res;
}

//-----------------------------------------------------------------------

int cmpstr(char far *S1, char far *S2) {
  int i = 0;
  while (S1[i]*S2[i]) {
    if (S1[i] != S2[i]) return(0);
    i++;
  };
  if (S1[i] != S2[i]) return(0); else return(1);
};

#pragma option -w-rvl
WORD packCol16(RGBcol color) {  // RGB 32bit (8:8:8) ==> RGB 16bit (5:6:5)
  asm {
    mov   ax, WORD ptr color[0]
    mov   dx, WORD ptr color[2]
    and   ax, 0x3F1F
    and   dx, 0x001F
    push  ax
    xor   ah, ah
    shl   dx, 11
    or    ax, dx
    pop   dx
    xor   dl, dl
    shr   dx, 3
    or    ax, dx
  }
}
#pragma option -w+rvl

RGBcol unpackCol16(WORD color) {  // RGB 16bit (5:6:5) ==> RGB 32bit (8:8:8)
  RGBcol tCol;
  tCol.align = 0;
  tCol.b = color&0x001F;
  tCol.g = (color&0x07E0)>>5;
  tCol.r = (color&0xF800)>>11;
  return tCol;
}

char curBank;

void VbePutPixel(WORD x, WORD y, RGBcol color) {
  DWORD base = (DWORD)modeinfo.WinASegment << 16;
  DWORD ofs = ((DWORD)modeinfo.XResolution*y+x)*(modeinfo.BitsPerPixel >> 3);
  if (curBank != ofs >> 16) {
    VbeSetDisplayWindow(0,ofs >> 16);
    curBank = ofs >> 16;
  }
  switch (modeinfo.BitsPerPixel) {
    case 8: {  // 256 color mode (palette, use color.b for color number)
      char far *pn = (char far *)(base+(WORD)ofs);
      *pn = color.b;
      break;
    }
    case 16: {
      WORD far *pn = (WORD far *)(base+(WORD)ofs);
      *pn = packCol16(color);
      break;
    }
    case 32: {
      char far *pn = (char far *)(base+(WORD)ofs);
      asm {
	les   di, pn
	mov   ax, WORD ptr color[0]
	stosw
	mov   al, BYTE ptr color[2]
	mov   es:[di], al
      }
      break;
    }
  }
}

class virtualScreenVesa/*:public virtualScreen*/ {
  public:
    int drawMode, drawMode_RC;
    virtualScreenVesa();
    ~virtualScreenVesa();
    virtual int error(int id);
    void clear(RGBcol color);
    void show();
    void copyTo(virtualScreenVesa *virscr);

    virtual void putpixel(WORD x, WORD y, RGBcol color);
    void line(WORD x1, WORD y1, WORD x2, WORD y2, RGBcol color);
    void frect(WORD x1, WORD y1, WORD x2, WORD y2, RGBcol color);

    void blur(WORD x1, WORD y1, WORD x2, WORD y2);
    void movement(WORD x1, WORD y1, WORD x2, WORD y2, void transCoord(WORD x,WORD y, WORD *xout,WORD *yout));
    void testf(WORD x1, WORD y1, WORD x2, WORD y2);
  protected:
    DWORD blockSize;
    WORD totBlocks;
    BYTE far *screen[8];  // max 8 memblock of 64Kb = 512Kb max!
    WORD far *getPnt(WORD x, WORD y);
};

virtualScreenVesa::virtualScreenVesa() {
  int i;
  drawMode = DM_NORMAL;
  drawMode_RC = 0;
  blockSize = 65535;//modeinfo.WinSize*1024;
  totBlocks = ((DWORD)modeinfo.YResolution*modeinfo.BytesPerScanLine)/(modeinfo.WinSize);
  totBlocks = totBlocks/1024 + (((totBlocks%1024)==0)?0:1);
  if (totBlocks > 8) error(4);

  for (i=0;i<totBlocks;i++) {
    unsigned int tSeg;
    if (allocmem(0x1000, &tSeg) != -1) error(0);
    screen[i] = (BYTE far *)((DWORD)tSeg << 16);
    /*screen[i] = (BYTE far *)farmalloc(blockSize);
    if (screen[i] == NULL) error(0);*/
  }
  //bufferIn = screen[0];
  //bufferOut = screen[0];

}

virtualScreenVesa::~virtualScreenVesa() {
  int i;
  for (i=0;i<totBlocks;i++) {
    //if (screen[i] == NULL) error(1); else farfree(screen[i]);
    WORD tSeg = (WORD)((DWORD)screen[i] >> 16);
    if (tSeg == NULL) error(1); else if (freemem(tSeg) != 0) error(2);
  }
}

int virtualScreenVesa::error(int id) {
  crt_setVideoMode(0x03);
  printf("ERROR %i",id);
  getch();
  exit;
  return(id);
}

void virtualScreenVesa::clear(RGBcol color) {
  int i;
  WORD clr = packCol16(color);
  for (i=0;i<totBlocks;i++) {
    BYTE far *pnt = screen[i];
    asm {
      push  es
      push  di
      les   di, pnt
      mov   cx, 0x8000
      mov   ax, clr
      rep   stosw
      pop   di
      pop   es
    }
    /*_fmemset(screen[i], clr, blockSize);
    *((WORD far *)screen[i]+0xFFFE) = clr;*/
  }
  i = color.r;
}

void virtualScreenVesa::show() {
  int i;
  void far *videoPtr = (void far *)((DWORD)modeinfo.WinASegment << 16);
  for (i=0;i<totBlocks;i++) {
    BYTE far *pnt = screen[i];
    VbeSetDisplayWindow(0,i);
    asm {
      push  es
      push  di
      push  ds
      push  si
      les   di, videoPtr
      lds   si, pnt
      mov   cx, 0x8000
      rep   movsw
      pop   si
      pop   ds
      pop   di
      pop   es
    }
    /*_fmemcpy(videoPtr, screen[i], blockSize);
    *((BYTE far *)videoPtr+0xFFFF) = *(screen[i]+0xFFFF);*/
  }
}

void virtualScreenVesa::copyTo(virtualScreenVesa *virscr) {
  int i;
  BYTE far *dest, far *source;
  for (i=0;i<min(totBlocks,virscr->totBlocks);i++) {
    dest = screen[i];
    source = virscr->screen[i];
    asm {
      push  es
      push  di
      push  ds
      push  si
      les   di, dest
      lds   si, source
      mov   cx, 0x8000
      rep   movsw
      pop   si
      pop   ds
      pop   di
      pop   es
    }
  }
}


void virtualScreenVesa::putpixel(WORD x, WORD y, RGBcol color) {
  int i;
  switch (modeinfo.BitsPerPixel) {
    case 8: {  // 256 color mode (palette, use color.b for color number)
      char far *pn = (char far *)getPnt(x,y);
      *pn = color.b;
      break;
    }
    case 16: {
      WORD far *pn = getPnt(x,y);
      switch (drawMode) {
	case DM_ADD: { *pn = packCol16(unpackCol16(*pn)+color); break; }
	case DM_NORMAL: ;
	default: *pn = packCol16(color);
      }
      break;
    }
    case 32: {
      BYTE far *pn = (BYTE far *)getPnt(x,y);
      asm {
	push  es
	push  di
	les   di, pn
	mov   ax, WORD ptr color[0]
	stosw
	mov   al, BYTE ptr color[2]
	mov   es:[di], al
	pop   di
	pop   es
      }
      break;
    }
  }
}

void virtualScreenVesa::line(WORD x1, WORD y1, WORD x2, WORD y2, RGBcol color) {
  int dx = x2-x1, dy = y2-y1,
      ix = abs(dx), iy = abs(dy),
      inct = (ix>iy?ix:iy),
      plotX = x1, plotY = y1,
      x = 0, y = 0,
      i;
  BYTE plot;
  putpixel(plotX,plotY, color);
  for (i=0;i<=inct;i++) {
    x += ix;
    y += iy;
    plot = 0;
    if (x > inct) {
      plot = 1;
      x -= inct;
      if (dx > 0) plotX++;
      if (dx < 0) plotX--;
     }
     //if (y = inct) putpixel(plotX, plotY, color/2);
     if (y > inct) {
       plot = 1;
       y -= inct;
       if (dy > 0) plotY++;
       if (dy < 0) plotY--;
     }
     if (plot) putpixel(plotX,plotY, color);
  }
}

void virtualScreenVesa::frect(WORD x1, WORD y1, WORD x2, WORD y2, RGBcol color) {
  WORD j, p;
  for (j=y1;j<=y2;j++)
    for (p=x1;p<=x2;p++) putpixel(p,j,color);
}

WORD far *virtualScreenVesa::getPnt(WORD x, WORD y) {
  DWORD base;
  //DWORD ofs = ((DWORD)modeinfo.XResolution*y+x)*(modeinfo.BitsPerPixel >> 3);
  WORD ofs;
  WORD Xsize = modeinfo.XResolution;
  BYTE bpp = modeinfo.BitsPerPixel;
  asm {
    mov   ax, Xsize
    mul   y
    add   ax, x
    adc   dx, 0
    mov   cl, bpp
    shr   cl, 4
    jz    skipShift // jump if bpp = 8
    shl   dx, cl
    rol   ax, cl
    mov   bl, al
    and   bl, cl
    or    dl, bl
    or    cl, 1
    not   cl
    and   al, cl
  } skipShift: asm {
    mov   ofs, ax
    mov   WORD ptr base[0], dx
  }
  base = (DWORD)screen[(BYTE)base];
  return (WORD far *)(base | ofs);
}

void virtualScreenVesa::blur(WORD x1, WORD y1, WORD x2, WORD y2) {
  RGBcol b1,b2,b3,b4;
  RGBcol c;
  WORD far *scrI;
  register int i, j;
  //if (!checkCoords(&x1,&y1,&x2,&y2)) return;
  j = y1;
  for (i=x1;i<=x2;i++) {
    scrI = getPnt(i,j);
    if ((WORD)scrI == 0) {
      b2 = unpackCol16(i==x1?0:*getPnt(i-1,j));
    } else b2 = unpackCol16(i==x1?0:*(scrI-1));
    if ((WORD)scrI >= 0xFFFE) {
      b3 = unpackCol16(i==x2?0:*getPnt(i+1,j));
    } else b3 = unpackCol16(i>=x2?0:*(scrI+1));
    b4 = unpackCol16(*getPnt(i,j+1));
    c.r = (b2.r+b3.r+b4.r)>>2;
    asm {   // calc green
      mov   al, BYTE ptr [b2+1]
      add   al, BYTE ptr [b3+1]
      add   al, BYTE ptr [b4+1]
      cmp   al, 0x02
      jb    noSub1
      sub   al, 0x02
    } noSub1: asm {
      shr   al, 2
      mov   BYTE ptr [c+1], al
    }
    c.b = (b2.b+b3.b+b4.b)>>2;
    *scrI = packCol16(c);
  }
  for (j=y1;j<y2;j++) {
    for (i=x1;i<=x2;i++) {
      scrI = getPnt(i,j);
      b1 = unpackCol16(*scrI);
      scrI = getPnt(i,j+1);
      if ((WORD)scrI == 0) {
	b2 = unpackCol16(i==x1?0:*getPnt(i-1,j));
      } else b2 = unpackCol16(i==x1?0:*(scrI-1));
      if ((WORD)scrI >= 0xFFFE) {
	b3 = unpackCol16(i==x2?0:*getPnt(i+1,j));
      } else b3 = unpackCol16(i==x2?0:*(scrI+1));
      b4 = unpackCol16(j==y2-1?0:*getPnt(i,j+2));
      c.r = (b1.r+b2.r+b3.r+b4.r)>>2;
      //c.g = (b1.g+b2.g+b3.g+b4.g-2)>>2;   // because green has 6 bits, not 5
      asm {
	mov   al, BYTE ptr [b1+1]
	add   al, BYTE ptr [b2+1]
	add   al, BYTE ptr [b3+1]
	add   al, BYTE ptr [b4+1]
	cmp   al, 0x02
	jb    noSub
	sub   al, 0x02
      } noSub: asm {
	shr   al, 2
	mov   BYTE ptr [c+1], al
      }
      c.b = (b1.b+b2.b+b3.b+b4.b)>>2;
      *scrI = packCol16(c);
    }
  }
}

void virtualScreenVesa::movement(WORD x1, WORD y1, WORD x2, WORD y2, void transCoord(WORD x,WORD y, WORD *xout,WORD *yout)) {
  WORD i,j, xn,yn;
  for (j=y1;j<=y2;j++) {
    for (i=x1;i<=x2;i++) {
      RGBcol color;
      transCoord(i,j, &xn,&yn);
      if ((xn >= modeinfo.XResolution)||(yn >= modeinfo.YResolution))
	//{xn %= VGA_WIDTH; yn %= VGA_HEIGHT; }
	{ color = COL_BLACK;}
      else
	color = unpackCol16(*getPnt(xn,yn));
	putpixel(i,j, color);
    }
  }
}



void virtualScreenVesa::testf(WORD x1, WORD y1, WORD x2, WORD y2) {
  RGBcol c;
  WORD far *scrI;
  register int i, j;
  for (j=y1;j<=y2;j++) {
    for (i=x1;i<=x2;i++) {
      scrI = getPnt(i,j);
      c = unpackCol16(*scrI);
      c.r = (c.r+c.g/2+c.b)/3;
      c.g = c.r*2;
      c.b = c.r;
      /*c.g = c.g^(((WORD)i|j)%8);
      c.r = c.r^(((WORD)i|j)%8);;
      c.b = c.b^(((WORD)i|j)%8);;*/
      *scrI = packCol16(c);
    }
  }
}

//-------------------------------------------------------------------

void trans(WORD x,WORD y, WORD *xout,WORD *yout) {
  float a,d, xf,yf;
  /*rec2pol_f4((int)x-160,(int)y-100, &d,&a);
  a = a+0.05;
  d = d*0.9;
  pol2rec_f4(d,a, &xf,&yf);
  *xout = (WORD)xf+160;
  *yout = (WORD)yf+100;*/

  *xout = x+5;//((int)x-160)/1.2+160;
  *yout = y-1;//((int)y-100)/1.2+100;
}


void main()
  {
    int md,wn,x,y;
    RGBcol col, col2;

    clrscr();

    VbeGetInfo();

    printf("Vesa card: %s\n",AP[cmpstr(vbeinfo.VbeSignature,"VESA")]);
    printf("Version: %x.%x\n",vbeinfo.VbeVersionF.High,vbeinfo.VbeVersionF.Low);
    printf("Oem name: %Fs\n",vbeinfo.OemStringPtr);
    printf("Video memory: %i Mb\n",vbeinfo.TotalMemory >> 4);

    md = g320x200x64K;
    VbeGetModeInfo(md);
    printf("\nMode: %ix%i at %ibpp\n",modeinfo.XResolution,modeinfo.YResolution,modeinfo.BitsPerPixel);
    printf("Supported: %s\n",TF[modeinfo.ModeAttributesF.Supported]);
    printf("Linear buffer: %s\n",TF[modeinfo.ModeAttributesF.LinearBuffer]);

    if (getch() == 0x1B) return;

    virtualScreenVesa *vir1 = new virtualScreenVesa();

    VbeSetMode(md);
    col.r = 0; col.g = 0; col.b = 0;
    vir1->clear(col);

    randomize();
    /*col.r = random(32);
    col.g = random(64);
    col.b = random(32);*/
    col.r = 3;
    col.g = 2;
    col.b = 3;
    /*col2.r = 1;
    col2.g = 0;
    col2.b = 0;*/
    vir1->drawMode = DM_ADD;
    while (!kbhit()) {
      int a,b;
    col.r = random(32/1);
    col.g = random(64/1);
    col.b = random(32/1);

      //col = col+col2;
      //vir1->line(random(320),random(200),random(320),random(200),col);
      x = random(320);
      y = random(200);
      vir1->frect(x,y,x+random(50),y+random(30),col/2);
      //vir1->movement(20,20,300,180, &trans);

      if (a%8==0) vir1->blur(0,0,319,199);
      //if ((a%16==0)) vir1->testf(10,10,310,180);

      if (a%4==0) vir1->show();
      a++;
    }
    getch();

    delete vir1;
    textmode(3);
    //printf("pnt %Fp",pn);
}