.MODEL SMALL
.8086
JUMPS


PUBLIC __vga_width, \
       __vga_height, \
       __vga_drawMode, \
       __vga_bufferSize, \
       __vga_screenIn, \
       __vga_screenOut, \
       __vga_data

PUBLIC __vga_errHandler, \
       __vga_show, \
       __vga_clear, \
       __vga_putpixel, \
       __vga_line, \
       __vga_hline, \
       __vga_circle

DM_NONE    EQU     0
DM_NORMAL  EQU     1
DM_ADD     EQU     2
DM_SUB1    EQU     3
DM_SUB2    EQU     4
DM_MUL     EQU     5
DM_AND     EQU     6
DM_OR      EQU     7
DM_XOR	   EQU     8
DM_MIN     EQU     9
DM_MAX     EQU    10
DM_BLEND50 EQU    11
DM_BLEND   EQU    DM_BLEND50


EXTDATA STRUC
  drawMode    DB ?,?
  width       DW ?
  height      DW ?
  bufferSize  DD ?
  bufferIn    DD ?
  bufferOut   DD ?
EXTDATA ENDS

.DATA

__vga_segment    DD 0A0000000h

__vga_width      DW 320
__vga_height     DW 200
__vga_drawMode   DB DM_NORMAL
__vga_screenIn   DD ?
__vga_screenOut  DD ?
__vga_bufferSize DD 64000

__vga_data DW ?

vga_error DB 'VGA error!',00Dh,00Ah,'Press a key to continue or Ctrl+C to exit.$'


.CODE

__vga_errHandler PROC
  mov   ax, 003h
  int   010h
  mov   ah, 009h
  mov   dx, OFFSET vga_error
  int   021h
  mov   ah, 008h
  int   021h
  ret
__vga_errHandler ENDP

__vga_show PROC
  push  ds es si di
  mov   si, __vga_data
  mov   cx, word PTR [si.bufferSize]
  shr   cx, 1
  les   di, [si.bufferOut]
  lds   si, [si.bufferIn]
  rep   movsw
  pop   di si es ds
  ret
__vga_show ENDP

__vga_clear PROC
color EQU [bp+4]
  push  bp
  mov   bp, sp
  push  es di si
  mov   si, __vga_data
  mov   cx, word PTR [si.bufferSize]
  shr   cx, 1
  les   di, [si.bufferOut]
  mov   al, color
  mov   ah, al
  rep   stosw
  pop   si di es
  pop   bp
  ret
__vga_clear ENDP

pp_dm_table DW pp_dm_none, pp_dm_normal, pp_dm_add, pp_dm_sub1, \
               pp_dm_sub2, pp_dm_mul, pp_dm_and, pp_dm_or, pp_dm_xor, \
               pp_dm_min, pp_dm_max, pp_dm_blend

__vga_putpixel PROC  ; returns zero if out of screen
; modified registers: AX, BX
x    EQU [bp+4]
y    EQU [bp+6]
col  EQU [bp+8]
  push  bp
  mov   bp, sp
  mov   ax, x
  mov   bx, y
  call  checkCoords
  jnc   pp_okCoords
  xor   ax, ax
  pop   bp
  ret
 pp_okCoords:
  push  ds es si di dx

  xchg  ax, bx
  mul   __vga_width
  add   ax, bx
  xor   bx, bx
  mov   bl, __vga_drawMode
  les   di, __vga_screenOut
  lds   si, __vga_screenIn
  add   si, ax
  add   di, ax

  cmp   bl, DM_BLEND
  ja    pp_dm_none
  mov   al, col
  shl   bx, 1
  mov   bx, cs:[pp_dm_table+bx]
  jmp   bx
 pp_dm_normal:              ; DM_NORMAL
  jmp   pp_draw
 pp_dm_add:                 ; DM_ADD
  add   al, ds:[si]
  jnc   pp_dm_add_nc
  mov   al, 0FFh
 pp_dm_add_nc:
  jmp   pp_draw
 pp_dm_sub1:                ; DM_SUB1
  mov   dl, ds:[si]
  sub   dl, al
  jnb   pp_dm_sub1_nb
  mov   al, 000h
 pp_dm_sub1_nb:
  mov   al, dl
  jmp   pp_draw
 pp_dm_sub2:                ; DM_SUB2
  sub   al, ds:[si]
  jnb   pp_dm_sub2_nb
  mov   al, 000h
 pp_dm_sub2_nb:
  jmp   pp_draw
 pp_dm_mul:                 ; DM_MUL
  mov   dl, ds:[si]
  mul   dl
  cmp   ah, 0
  je    pp_dm_mul_nc
  mov   al, 0FFh
 pp_dm_mul_nc:
  jmp   pp_draw
 pp_dm_and:                 ; DM_AND
  and   al, ds:[si]
  jmp   pp_draw
 pp_dm_or:                  ; DM_OR
  or    al, ds:[si]
  jmp   pp_draw
 pp_dm_xor:                 ; DM_XOR
  xor   al, ds:[si]
  jmp   pp_draw
 pp_dm_min:                 ; DM_MIN
  mov   ah, ds:[si]
  cmp   al, ah
  jbe   pp_dm_min_b
  mov   al, ah
 pp_dm_min_b:
  jmp   pp_draw
 pp_dm_max:                 ; DM_MAX
  mov   ah, ds:[si]
  cmp   al, ah
  jae   pp_dm_max_b
  mov   al, ah
 pp_dm_max_b:
  jmp   pp_draw
 pp_dm_blend:               ; DM_BLEND
  mov   dl, ds:[si]
  xor   ah, ah
  xor   dh, dh
  add   ax, dx
  shr   ax, 1
 pp_draw:
  mov   es:[di], al
 pp_dm_none:
  pop   dx di si es ds
  mov   ax, 1
  pop   bp
  ret
__vga_putpixel ENDP

__vga_line PROC
; modified registers: AX, BX, CX, DX
x1   EQU [bp+4]
y1   EQU [bp+6]
x2   EQU [bp+8]
y2   EQU [bp+10]
col  EQU [bp+12]
dinc1   EQU [bp-2]
dinc2   EQU [bp-4]
xinc1   EQU [bp-6]
xinc2   EQU [bp-8]
yinc1   EQU [bp-10]
yinc2   EQU [bp-12]

  push  bp             ; entry point
  mov   bp, sp
  sub   sp, 12

  mov   bx, x2         ; calculates deltax
  sub   bx, x1
  jnb   l_dx_nb
  neg   bx
 l_dx_nb:              ; bx = deltax
  mov   ax, y2         ; calculates deltay
  sub   ax, y1
  jnb   l_dy_nb
  neg   ax
 l_dy_nb:              ; ax = deltay

  mov   cx, 00001h
  cmp   bx, ax         ; if (deltax >= deltay) ...
  jb    l_dd_end
  xchg  ax, bx
  xchg  ch, cl
 l_dd_end:

  and   word PTR xinc1, 0
  and   word PTR yinc1, 0
  mov   byte PTR xinc1, ch
  mov   byte PTR yinc1, cl
  mov   word PTR xinc2, 1
  mov   word PTR yinc2, 1
  mov   cx, ax
  inc   cx             ; cx = deltayx+1 (len)
  mov   dx, bx
  shl   dx, 1
  mov   dinc1, dx      ; dinc1 = deltaxy*2
  sub   dx, ax         ; dx = deltaxy*2 - deltayx
  neg   ax
  add   ax, bx
  shl   ax, 1
  mov   dinc2, ax      ; dinc2 = (deltaxy-deltayx)*2

  mov   ax, x1
  mov   bx, y1

  cmp   ax, x2            ; if (x1 > x2)
  jle   l_xx_le
  neg   word PTR xinc1
  neg   word PTR xinc2
 l_xx_le:
  cmp   bx, y2            ; if (y1 > y2)
  jle   l_yy_le
  neg   word PTR yinc1
  neg   word PTR yinc2
 l_yy_le:

  push  si
  mov   si, 1
 l_startline:
  push  col
  push  bx
  push  ax
  call  __vga_putpixel
  cmp   ax, 0
  je    l_nopx
  xor   si, si
  jmp   l_endpx
 l_nopx:
  test  si, 1
  jnz   l_endpx
  jmp   l_endline
 l_endpx:
  pop   ax
  pop   bx
  add   sp, 2

  cmp   dx, 0             ; if (d < 0) ...
  jge   l_dp_ge
  add   dx, dinc1
  add   ax, xinc1
  add   bx, yinc1
  jmp   l_dp_end
 l_dp_ge:                 ; else ...
  add   dx, dinc2
  add   ax, xinc2
  add   bx, yinc2
 l_dp_end:

  dec   cx
  jcxz  l_endline
  jmp   l_startline
 l_endline:
  pop   si

  mov   sp, bp
  pop   bp
  ret
__vga_line ENDP

__vga_hline PROC
; modified registers: AX, BX, CX
x1   EQU [bp+4]
x2   EQU [bp+6]
y    EQU [bp+8]
col  EQU [bp+10]
  push  bp
  mov   bp, sp
  mov   ax, x1
  mov   bx, x2
  cmp   ax, bx            ; if (x1 > x2) ...
  jle   hl_okorder
  xchg  ax, bx
 hl_okorder:              ; ... endif
  cmp   ax, 0             ; if (x1 < 0) ...
  jge   hl_okx1
  xor   ax, ax            ; x1 = 0
 hl_okx1:                 ; ... endif
  cmp   bx, __vga_width   ; if (x2 >= width)
  jl    hl_okx2
  mov   bx, __vga_width   ; x2 = width
 hl_okx2:                 ; ... endif
  cmp   ax, __vga_width
  jge   hl_endfunc
  cmp   bx, 0
  jl    hl_endfunc
  mov   cx, bx
  sub   cx, ax
  inc   cx                ; len = x2-x1+1
  mov   bx, y
  cmp   bx, __vga_height
  jae   hl_endfunc
  push  col
  push  y
 hl_loop:
  push  ax
  call  __vga_putpixel
  pop   ax
  inc   ax
  dec   cx
  jcxz  hl_endloop
  jmp   hl_loop
 hl_endloop:
  add   sp, 4
 hl_endfunc:
  pop   bp
  ret
__vga_hline ENDP

__vga_circle PROC
; modified registers: AX, BX
x    EQU [bp+4]
y    EQU [bp+6]
rad  EQU [bp+8]
col  EQU [bp+10]
x1  EQU [bp-2]
x2  EQU [bp-4]
x3  EQU [bp-6]
x4  EQU [bp-8]
y1  EQU [bp-10]
y2  EQU [bp-12]
y3  EQU [bp-14]
y4  EQU [bp-16]
  push  bp
  mov   bp, sp
  sub   sp, 16
  push  cx dx

  mov   ax, 0             ; nx = 0
  mov   bx, rad           ; ny = rad
  mov   cx, x
  mov   dx, y

  mov   x1, cx            ; x1 = x+nx = x
  mov   x2, cx            ; x2 = x-nx = x
  mov   x3, cx
  add   x3, bx            ; x3 = x+ny
  mov   x4, cx
  sub   x4, bx            ; x4 = x-ny
  mov   y1, dx
  add   y1, bx            ; y1 = y+ny
  mov   y2, dx
  sub   y2, bx            ; y2 = y-ny
  mov   y3, dx            ; y3 = y+nx = y
  mov   y4, dx            ; y4 = y-nx = y

  mov   dx, bx
  shl   dx, 1
  neg   dx
  add   dx, 3             ; dx = 3 - rad*2

 c_start:
  cmp   ax, bx            ; while (nx <= ny) ...
  jg    c_end

  push  ax bx
  push  col
  push  y1
  push  x1
  call  __vga_putpixel    ; putpixel(x1,y1, col)
  add   sp, 4
  push  y2
  push  x1
  call  __vga_putpixel    ; putpixel(x1,y2, col)
  mov   ax, x2
  cmp   ax, x1
  je    c_nodraw1         ; if (x1 != x2) ...
  add   sp, 4
  push  y1
  push  ax
  call  __vga_putpixel    ; putpixel(x2,y1, col)
  add   sp, 4
  push  y2
  push  x2
  call  __vga_putpixel    ; putpixel(x2,y2, col)
 c_nodraw1:
  mov   ax, y3
  cmp   ax, y1
  je    c_nodraw2         ; if (y1 != y3) ...
  add   sp, 4
  push  ax
  push  x3
  call  __vga_putpixel    ; putpixel(x3,y3, col)
  add   sp, 4
  push  y3
  push  x4
  call  __vga_putpixel    ; putpixel(x4,y3, col)
  mov   ax, y4
  cmp   ax, y3
  je    c_nodraw2         ; if (y3 != y4) ...
  add   sp, 4
  push  ax
  push  x3
  call  __vga_putpixel    ; putpixel(x3,y4, col)
  add   sp, 4
  push  y4
  push  x4
  call  __vga_putpixel    ; putpixel(x4,y4, col)
 c_nodraw2:
  add   sp, 6
  pop   bx ax

  inc   ax                ; nx++
  inc   word PTR x1       ; x1++
  dec   word PTR x2       ; x2--
  inc   word PTR y3       ; y3++
  dec   word PTR y4       ; y4--

  cmp   dx, 0             ; if (d < 0) ...
  jge   c_d0_ge
  mov   cx, ax
  shl   cx, 2
  add   cx, 6
  add   dx, cx            ; d += nx*4 + 6
  jmp   c_d0_end
 c_d0_ge:                 ; else ...
  mov   cx, ax
  sub   cx, bx
  shl   cx, 2
  add   cx, 10
  add   dx, cx            ; d += (nx-ny)*4 + 10
  dec   bx                ; ny--
  dec   word PTR x3       ; x3--
  inc   word PTR x4       ; x4++
  dec   word PTR y1       ; y1--
  inc   word PTR y2       ; y2++
 c_d0_end:
  jmp   c_start
 c_end:

  pop   dx cx
  mov   sp, bp
  pop   bp
  ret
__vga_circle ENDP



checkCoords:
; input:  AX = X, BX = Y
; output: carry flag if bad
  cmp  ax, 0
  jl   cc_badCoords
  cmp  bx, 0
  jl   cc_badCoords
  cmp  ax, __vga_width
  jge  cc_badCoords
  cmp  bx, __vga_height
  jge  cc_badCoords
  clc
  ret
cc_badCoords:
  stc
  ret


IFDEF USE386
INCLUDE vga2_386.asm
ENDIF

END