#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt.h>
#include <vga.h>
#include <vgapal.h>
#include <math.h>

#include "bmp.cpp"
char fname[100];
int ct = 0;

#define SIZEZ    400

#define VIEWSIZE  40
//#define WSIZEX      40
#define WSIZEZ   100
#define SPACING    (160/VIEWSIZE+1)

typedef struct {
  short x,y,z;
} POINT3D;

VirtualScreen *vir1;
pal256 pal1;

short ys[WSIZEZ][VIEWSIZE];
BYTE cols[WSIZEZ][VIEWSIZE];

void to2d(POINT3D *pt3d, int *x, int *y) {
  /**x = (long)pt3d->x*(pt3d->z+SIZEZ/2)/SIZEZ;
  *y = (long)pt3d->y*(pt3d->z+SIZEZ/2)/SIZEZ;*/
  asm {
    /*push si
    push di*/
    push bx
    push cx
    mov  si, pt3d
    mov  cx, [si+4] //[si+offset pt3d.z-offset pt3d]
    add  cx, SIZEZ/2
    mov  bx, SIZEZ
    mov  ax, [si+0] //[si+offset pt3d.x-offset pt3d]
    imul cx
    idiv bx
    mov  di, x
    mov  [di], ax
    mov  ax, [si+2] //[si+offset pt3d.x-offset pt3d]
    imul cx
    idiv bx
    mov  di, y
    mov  [di], ax
    pop  cx
    pop  bx
    /*pop  di
    pop  si*/
  }
}

void rotateOY(POINT3D *p3d, double sinbeta, double cosbeta) {
// rotate around y-axis
  double rx,rz;
  rx = p3d->x*cosbeta - p3d->z*sinbeta;
  rz = p3d->z*cosbeta + p3d->x*sinbeta;
  p3d->x = (int)rx;
  p3d->z = (int)rz;
}

void initPts() {
  const int mounts = 20;
  register int i,j,k;
  short y, rx[mounts], ry[mounts], h[mounts], l;

  for (i=0; i<mounts; i++) {
    rx[i] = random(VIEWSIZE);
    ry[i] = random(WSIZEZ);
    h[i] = random(random(200)+150)+random(80);
  }
  for (j=0; j<WSIZEZ; j++) {
    for (i=0; i<VIEWSIZE; i++) {
      y = 0;
      for (k=0; k<mounts; k++) {
        l = (int)(((double)h[k]/((i-rx[k])*(i-rx[k])+16.0)) *
                  ((double)(h[k]/10.0)/((j-ry[k])*(j-ry[k])+21.0)));
        y += l;
      }
      y -= 70-random(2);
      ys[j][i] = y;
      cols[j][i] = min((y+71)*4,255);
    }
  }
}

int main() {
  register int i,j;
  int k, x,y, counter = 0;
  POINT3D pt;

  crt_setVideoMode(0x13);
  vir1 = new VirtualScreen();
  vir1->clear(0);

  pal_setGradient(&pal1, 1,5, 0,0,0, 10,10,40);
  pal_setGradient(&pal1, 6,10, 10,10,40, 15,50,60);
  pal_setGradient(&pal1, 11,15, 63,60,5, 20,55,20);
  pal_setGradient(&pal1, 16,70, 20,55,20, 40,47,20);
  pal_setGradient(&pal1, 71,120, 40,47,20, 62,60,60);
  pal_setGradient(&pal1, 121,255, 62,60,60, 63,63,63);
  pal_outAll(&pal1);

  srand(time(0));
  initPts();
  do {
    double alpha = counter/100.0;
    double s = sin(alpha),
           c = cos(alpha);

    for (j=0; j<VIEWSIZE; j++) {
      k = (j+counter)%WSIZEZ;
      for (i=0; i<VIEWSIZE; i++) {
        pt.x = (i-VIEWSIZE/2)*SPACING;
        pt.y = ys[k][i];
        pt.z = (j-VIEWSIZE/2)*SPACING;
        rotateOY(&pt, s,c);
        pt.z += 150;
        to2d(&pt, &x, &y);
        vir1->putPixel(x+160,100-y, cols[k][i]);
      }
    }
    vir1->show();

/*    sprintf(fname, "worldout/%i.bmp",ct++);
    bmpWrite(fname, vir1, &pal1, 0,0,319,199);
*/
    vir1->clear(0);
    delay(5);
    counter++;
  } while (!kbhit());
  getch();

  delete vir1;
  crt_restoreVideoMode();
  return(0);
}